globals [initialactors intervention-initial intervention-freq-type catchab-counter subs-cap_part_unit subs-loy_part_unit subs_cap_tot_part subs_loy_tot_part capital-lower-limit-signal loyalty-lower-limit-signal subs-cap-initial subs-loy-initial subs-cap subs-loy maxcoopmemberloyalty fisherspriceproportionEQ maxcapitalbuyer maxcapitalfisher maxcapitalcoopcapital initialcoopcapital initialcapitalbuyer list-coop-catches subs_cap_tot subs_loy_tot   marketdemand entry-type max-num-coops-to-transform num-coops-transformed intervalforentering  eq_no_cheating eq_cheating cooployaltygrowthrate maxgroupsizebuyers marketdemandMSY beginfilewriting   initialcapital  my-seed   save_interval timewithbuyer-list timealivebuyer-list timewithcoop-list num-coops-dissolve-capital num-coops-dissolve-size num-coops-dissolve-loyalty num-coop-fishers-exit-loyalty num-pc-fishers-exit-buyer num-coop-fishers-exit-capital num-coop-fishers-exit-size num-buyers-exit-capital num-coop-cheaters num-pc-cheaters marketpriceEQ list-taken-coop-ids list-free-coop-ids list-free-coop-names inactive-fishers-capital buyers-credits growthrate  growthrateEQ MSYstock dailyconsumptionbuyer MSYfishers mincoopsize maxcoopswithinclan numclans coopfishersmarketshare intervalforbuyerentering   coop-fishers-coop-capital active-fishers-loyalty active-coop-fishers-loyalty  active-pc-fishers-loyalty active-buyers-capital active-pc-fishers-capital active-coop-fishers-capital coopbudgets coopindbudgets num-buyers active-pc-fishers num-active-pc-fishers active-coop-fishers num-active-coop-fishers active-fishers num-inactive-fishers num-active-fishers inactive-fishers stock carryingcapacity totalcatch totaleffort sdthreshold  marketprice dailyconsumptionfisher dailycostoffishing num-coops buyermincapital gini-index-reserve-final gini-index-reserve-coop-final gini-index-reserve-pc-final  lorenz-points intervalforcoopentering  groupsizeEQ coopmincapitalconst coopfee MSYyieldfisher incnewbuyersprice coopmaintenacecosts ind-capital-coop ind-capital-pc ind-capital-buyers]
extensions [profiler]

breed   [ actors      actor  ]
breed   [ fishers     fisher ]
breed   [ buyers      buyer  ]
breed   [ wholesalers wholesaler ] ;; what coop sell to (and later maybe also the buyer)
                                   ; serach for xxx warning changed for testing
undirected-link-breed [partnerships partnership] ; connection between buyer and fisher i.e. PC
undirected-link-breed [friendships friendship]   ; connection between actors in a i.e. COOP
undirected-link-breed [businesses business]      ; connection between a COOP and their wholesaler

turtles-own [  ; all breeds own
  capital
  individualeffort

  managerialskills
  coopmanagerialskills
  fishingskills
  socialskills
  licence
  clanid
  revenue
  reliability
  reputation ; reliability * fishingskills
  credits
  timestepsalive
]

actors-own  [ ]

fishers-own [
  coopid   ; coopid can be reused
  coopname ; to keep track of each coop
  loyalty
  fishedcatch
  loan
  coopfishermarketdemand ;
  primarybuyer ; only PC fihers
  primarywholesaler ; only coop fishers
  secondarybuyer ;if fisher is cheating this is set to either a buyer breed, or a fisher breed if the fisher buying the catch is in a coop
  coopcapital
  timewithcoop
  timewithbuyer
  price ; the price that the fisher gives to another fisher which is cheating by selling his catch to this fisher
  stayin ; coop fishers dont go fishing every timestep, if=1 dont go fishing'
  subs_available ; if a subsudie is available to the coop
]

buyers-own  [
  price
  creditslost
  buyermarketshare
  buyerdemand
  fleetcatch
  ;unreliablefishers-set
  ;costoftradingcatch
]

wholesalers-own [ ;  xxxx might keep track of capital ...
  price
  payedtofisher ; not used
]

partnerships-own [ ]  ; longer commitment increase bfloyalty. (bf: buyer to fisher)
friendships-own  [ ]  ; longer commitment increase ffloyalty. (ff: fisher to fisher) NB. Using loyalty in fishers instead
businesses-own   [timesteps] ; how many timesteps the coop has been selling to this wholesaler

                             ; xxx set color scale according to social class, and size to wealth? use shape to vizualize a third thing?
                             ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
                             ;; SETUP
                             ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
to setup
  clear-all
  if seedtype = "seed based on run" [random-seed (runs + 102)] ; 101 in first ursus runs, 102 in second different run different seed different randomness, but run 1 in constant world will be  same as run 1 in seasonal world
  if seedtype = "seed 1" [random-seed (runs + 1)] ; for testing
  if seedtype = "seed 2" [random-seed (runs + 2)] ; for testing
  if seedtype = "seed 3" [random-seed (runs + 3)] ; for testing
  if seedtype = "seed 4" [random-seed (runs + 4)] ; for testing
  if seedtype = "seed 5" [random-seed (runs + 5)] ; for testing
  set-default-shape turtles "circle"
  ;import-drawing "kinobay.jpg"

  set-amount-go-negative
  set-cooployaltygrowthrate
  set subs_cap_tot 0
  set subs_loy_tot 0
  set intervalforentering 1 ; after 100 years so will not happen, leave in because we might change later
  ;set PC_gr_size_multiple 1 ; 1 is same as coop.  num fishers times coop membersa PC can have, ie PC can grow more than coops if > 1
  set decrease_netincome_constant 0 ; 0 means no decrease, no effect on fixed calibration because they never get more money
  ;set coop_savings_const 0.6          ; 1 means no saving, effects calibration that coops get risher
  ; let reduce_daily_consumption 1    ; 1 means MSY calibrated, use 0.9?, reduce costs means fishers can survive below MSY, effects that all fishers and buyers get risher
  set decrease_individualeffort 1   ; 1 means no decrease, effects calibration <1 fishers don't make enough money so all go out of business, >1 gives overfishing
  set num-coops-transformed 0
  set max-num-coops-to-transform 10
  set catchability 1
  if (ecosystemdynamicstype = "uncertain" OR ecosystemdynamicstype = "uncertain+seasonal" ) AND catchability-var = 0 [
    set catchability-var 0.9
  ]
  set initialactors 100
  set do-layout false
  set print-std-out FALSE
  set write-on true  ; for exporting csv file
  set save_interval 100  ; how often to write to file in order to make smaller files, avoid 365 since they enter every 365 ts.
  set list-taken-coop-ids (list)
  set list-free-coop-ids n-values round (initialactors / 5) [ [?1] -> ?1 + 1 ]
  set list-free-coop-names n-values initialactors [ [?1] -> ?1 + 1 ]
  set list-coop-catches (list)
  set lorenz-points []
  set coopbudgets []
  set coopindbudgets []
  set active-pc-fishers n-of 0 turtles
  set num-active-pc-fishers 0
  set active-coop-fishers n-of 0 turtles
  set num-active-coop-fishers 0
  set active-fishers n-of 0 turtles
  set num-active-fishers 0
  set num-inactive-fishers 0
  set inactive-fishers n-of 0 turtles
  set active-fishers-loyalty 0
  set active-coop-fishers-capital 0
  set active-pc-fishers-capital 0
  set active-buyers-capital 0
  set buyers-credits 0
  set coop-fishers-coop-capital 0
  set active-coop-fishers-loyalty 0
  set active-pc-fishers-loyalty 0
  set maxcoopmemberloyalty 365
  set num-coops 0
  set ind-capital-coop 0
  set ind-capital-pc 0
  set ind-capital-buyers 0
  set num-coop-cheaters 0
  set num-pc-cheaters 0
  set num-coop-fishers-exit-loyalty 0
  set num-pc-fishers-exit-buyer 0
  set num-coop-fishers-exit-capital 0
  set num-coop-fishers-exit-size 0
  set num-buyers-exit-capital 0
  set num-coops-dissolve-capital 0
  set num-coops-dissolve-size 0
  set num-coops-dissolve-loyalty 0
  set timewithbuyer-list []
  set timewithcoop-list []
  set timealivebuyer-list []
  set eq_no_cheating 1 ; "eq" when no cheating
  set eq_cheating 0.66; calibrated eq when cheating is on and only PC for the transformation paper

  ;;;;;;;;;;;;;;;;;;;;;;;;;;;  CONSTANTS  (used for setting/resetting model)   ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
  set intervalforbuyerentering round (365 * intervalforentering )
  set intervalforcoopentering intervalforbuyerentering ; reset for pc trans coops do not enter we transform instead
  ;;
  ;; ECOSYSTEM
  ;;
  set carryingcapacity 100              ;; max stock capacity to ecosystem can support

  set stock carryingcapacity / 2                          ;; (initial) stock, changes each time step, initial at carryingcap gives about 12 years before stabilizing at MSY, money about 1200 units for buyers and coops
  set MSYstock carryingcapacity / 2                       ;; MSY stock

  set growthrate growthrateinitial          ;; growth rate of fish, can change later so need fixed for equilibrium calculations
  set growthrateEQ 0.001
  ;set growthrateEQ 0.4 / 365
  let MSYyield MSYstock * ( growthrateEQ / 2 )

  ;s set ecosystemdynamicstype "constant" ;; test effect of different dynamics
  set MSYfishers 50;; can be changed to any number < initial actors
  ;;
  ;; MARKET
  ;;

  let marketgrowthrate  1         ;; only used if we make gradual change to market dynamics
  let marketdynamicstype "fixed"  ;; fixed the only one implemeted so far
                                  ;set fishingcapacity growthrateinitial / 2 * MSYstock / buyernumfishersatEQ ; tonnes of fish

  set marketdemandMSY  MSYyield ; MSYstock * growthrateinitial / 2 / MSYfishers * buyernumfishersatEQ / buyersmarketshareEQ
  set marketdemand marketdemandMSY
                                                 ; set totalmarketshares 1         ;; xxx total available market shares (1=100%), use later and market demand can stear available demand/quotas

  set fisherspriceproportionEQ 0.8 ;; % of marketprice [0 1] note if 0 marketprice is 0
                                   ;;
                                   ;; CLANS
                                   ;;
  set numclans 3
  ;;
  ;; FISHER
  ;;
  set groupsizeEQ 5 ;
  set maxgroupsizebuyers groupsizeEQ * PC_gr_size_multiple;

  set MSYyieldfisher MSYyield / MSYfishers


  ;;
  ;; COOP
  ;;
  ;let maxinitialcoopsize 10    ;; max num fishers when starting a coop
  ;let mininitialcoopsize 6     ;; min num fishers when starting a coop
  ;set maxcoopswithinclan 6     ;; a clan can have max coops within (xxx should be calculated)
  set mincoopsize 3            ;; if a coop has less than mincoopsize it dissolves
  set coopfishersmarketshare 1 / MSYfishers
  set coopmincapitalconst amountgonegative


  ;;
  ;; BUYER
  ;;
  set buyermincapital amountgonegative

  let MSYyieldbuyer MSYyieldfisher * groupsizeEQ

  let dailyconsumptionbuyerMSY 5
  set dailyconsumptionbuyer dailyconsumptionbuyerMSY * reduce_daily_consumption
  set marketpriceEQ dailyconsumptionbuyerMSY / (( 1 - fisherspriceproportionEQ ) * MSYyieldbuyer)
  let incomefisherEQ marketpriceEQ * fisherspriceproportionEQ * MSYyieldfisher
  let incomecoopfisherEQ marketpriceEQ * MSYyieldfisher
  let expensesfisherEQ incomefisherEQ ;shold go + / - 0
  let expensescoopfisherEQ incomecoopfisherEQ ;shold go + / - 0
  let dailyloanproportionfisher 0.15              ;; cof cost of fishing part

  set dailycostoffishing expensesfisherEQ * dailyloanproportionfisher
  ; set dailygasandlunchloan dailycostoffishing
  ; xxxx set dailycostoffishing to dailtgasandlunchloan
  let dailyconsumptionfisherMSY expensesfisherEQ * (1 - dailyloanproportionfisher) ;; cost of daily "living"
  set initialcapital dailyconsumptionfisherMSY * 7 ; can survive one week without fishing
  set dailyconsumptionfisher (expensesfisherEQ * (1 - dailyloanproportionfisher)) * reduce_daily_consumption ;; NEW xxx reduce cost of fishingto have overfishing
  set coopfee expensescoopfisherEQ - dailyconsumptionfisherMSY - dailycostoffishing

  set initialcapitalbuyer dailyconsumptionbuyer * 30 ; can survive one month without income
  set initialcoopcapital  initialcapitalbuyer  / groupsizeEQ

  ; capping data
  let to-month 4.5 ; because fishers initial capital is only for 1 week
  ;capping is relational to the amount the initial capital, and can last for 3 years
  set maxcapitalfisher      3  * initialcapital * to-month ; to survive x months
  set maxcapitalbuyer       12 * initialcapitalbuyer
  set maxcapitalcoopcapital 12 * initialcoopcapital

  ; initial subsidie and how much to distribute
  set subs-cap-initial initialcoopcapital * 2
  set subs-loy-initial 35   ; extra per per fisher 70*5 = 350




  set subs-cap_part_unit subs-cap-initial
  set subs-loy_part_unit subs-loy-initial

  ;show (subs-cap-initial /  subs-cap_part_unit) * 5 * 10
  ;  show subs-loy-initial /  subs-loy_part_unit * 5 * 10

  set intervention-freq-type "none"
  set intervention-initial "none"

  if intervention-matching != "none" [
    if intervention-matching = "icap" [
      set intervention-freq-type  "none"
      set intervention-initial "cap"
    ]
    if intervention-matching = "iloy" [
      set intervention-freq-type  "none"
      set intervention-initial "loy"
    ]
    if intervention-matching = "icap+iloy" [
      set intervention-freq-type  "none"
      set intervention-initial "cap+loy"
    ]
    if intervention-matching = "cap" [
      set intervention-freq-type  "cap"
      set intervention-initial "cap"
    ]
    if intervention-matching = "loy" [
      set intervention-freq-type  "loy"
      set intervention-initial "loy"
    ]
    if intervention-matching = "cap+loy" [
      set intervention-freq-type  "cap+loy"
      set intervention-initial "cap+loy"
    ]
  ]
  if  intervention-signal != "none" [
    set subs-cap subs-cap-initial  * ( intervention-freq / 12 )
    set subs-loy subs-loy-initial * ( intervention-freq / 12 )
  ]




  if print-std-out = true [
    type "subs-cap-initial " show subs-cap-initial
    type "subs-loy-initial " show subs-loy-initial

    type "initialcapital fisher " show initialcapital
    type "initialcapitalbuyer " show initialcapitalbuyer
    type "initialcoopcapital " show initialcoopcapital

    type " maxcapitalfisher  " show maxcapitalfisher
    type " maxcapitalbuyer " show maxcapitalbuyer
    type " maxcapitalcoopcapital " show maxcapitalcoopcapital

    type "subs-cap " show subs-cap
    type "subs-loy " show subs-loy

    type " income COOP fisherEQ: "     show incomecoopfisherEQ
    type " income PC fisherEQ: "       show incomefisherEQ
    type " dailycostoffishing: "       show dailycostoffishing
    type " coopfee: "                  show coopfee
    type " dailyconsumption fisher: "  show dailyconsumptionfisher
    type " dailyconsumption buyer: "   show dailyconsumptionbuyer
    type " out COOP fisher: "          show dailycostoffishing + coopfee + dailyconsumptionfisher
    type " out PC fisher: "            show  dailycostoffishing + dailyconsumptionfisher

  ]


  set-marketprice

 ;type  " marketprice "  type marketprice type  " marketprice EQ"  type marketpriceEQ type " dailyconsumptionbuyerMSY " type dailyconsumptionbuyerMSY type " pricefisherEQ " type fisherspriceproportionEQ type "( 1 - fisherspriceproportionEQ ) * MSYyieldbuyer DIVTERM " type ( 1 - fisherspriceproportionEQ ) * MSYyieldbuyer  type " MSYyieldbuyer " show MSYyieldbuyer
  create-wholesalers 1 [
    set price marketprice                       ;; wholesalers represents market at this point
    setxy pxcor + 15 pycor - 15
    set color orange
    set size 3
    set shape "house"
  ]
  setup-fishers-buyers-coops

  reset-ticks
  layout

end

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; TO setup interface - resets the filenames so they are not overwritten
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

to setup-interface

  set filenameLife "Life_Interface.csv"
  set filenameNum "Num_Interface.csv"
  set filenameStr "Str_Interface.csv"
  set filenameBrs "Brs_Interface.csv"
  set filenameFshInCP "FshInCP_Interface.csv"
  set filenameFshwBr "FshwBr_Interface.csv"
  setup
end

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; TO GO - EACH TIME STEP THE FOLLOWING PROCEDURE IS DONE
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
to go

  ;;update-marketdemand

  ;;;;;;;;;;;;;;;;;;;; DAILY ;;;;;;;;;;;;;;;;;;;;


  let random-change  7 + random 15 ;; change on average every 14 timesteps start after a week
  if (ecosystemdynamicstype = "uncertain" OR ecosystemdynamicstype = "uncertain+seasonal") AND ticks mod random-change = 0 [
    set catchability min_ 2 max_ 0 ( random-normal 1 catchability-var )
  ]

  ask actors [
    actor-turn-fisher
  ]

  update-marketprice

  if initconfigpccoops = "pc evolving" OR  initconfigpccoops = "pc"[

    if (ticks mod (intervalforbuyerentering * 1) = 0 AND ticks > 0 ) OR (initconfigpccoops = "pc evolving" AND ticks = 0) [

      select-fisher-turn-buyer 1
      ask buyers with [timestepsalive = 0] [
        setup-buyers-shares-demand-price    ;; deal potentially avliable market shares to new buyer
        repeat groupsizeEQ [ buyer-select-fisher nobody]
      ]
    ]
  ]


  if initconfigpccoops = "pc trans" AND ticks > 0 [
    ;if stock > MSYstock AND (ticks mod 365 = 0) [ ; a new buyer can enter
    if ticks mod 365 = 0 [ ; a new buyer can enter
                           ;type "stock" show stock
                           ;type "MSY stock" show MSYstock
      select-fisher-turn-buyer 1
    ]
    if count buyers < 10 AND ticks < 365 [ ; always keep 10 buyers alive the first year
      select-fisher-turn-buyer 1
    ]

    ask buyers with [ timestepsalive = 0 OR (timestepsalive = 1  AND ticks > 1)] [  ; the buyer formed when a coop dissolved
      setup-buyers-shares-demand-price    ;; deal potentially avliable market shares to new buyer
      repeat groupsizeEQ [ buyer-select-fisher nobody]
    ]
    ; special case
    if coops_continue_entering = TRUE [
      if ticks mod (intervalforcoopentering * 1) = 0 AND ticks >= 4 * 365 [
        coop-forms
      ]
    ]
  ]


  if initconfigpccoops = "coops evolving" OR initconfigpccoops = "coops"[

    if (ticks mod (intervalforcoopentering * 1) = 0 AND ticks > 0) OR (initconfigpccoops = "coops evolving" AND ticks = 0) [
      coop-forms
    ]
  ]
  if initconfigpccoops = "mixed evolving" OR (initconfigpccoops = "mixed" AND ticks >= intervalforcoopentering) [

    if ticks mod (intervalforcoopentering * 1) = 0 [
      coop-forms
    ]
    if ticks mod (intervalforcoopentering * 1) = 0 [
      select-fisher-turn-buyer 1
      ask buyers with [timestepsalive = 0] [
        setup-buyers-shares-demand-price    ;; deal potentially avliable market shares to new buyer
        repeat groupsizeEQ [ buyer-select-fisher nobody]
      ]
    ]
  ]

 coop-transforms ; checks if to form a coop, and forms one if true
 coop-do-intervention ; checks signals for subsidie and gives it/them

  if any? buyers [

    set timealivebuyer-list [] ; plot how long buyers are active
    ask buyers [
      set buyerdemand buyermarketshare * marketdemand
      set timealivebuyer-list lput timestepsalive timealivebuyer-list
      if (ticks mod 15 = 1) AND (initconfigpccoops != "mixed fixed")  AND (initconfigpccoops != "pc fixed") AND (initconfigpccoops != "coops fixed") [
        buyer-de-select-fishers
      ]
      set price marketprice * fisherspriceproportionEQ ; set buyers price to fishers
    ]
  ]

  ;; iterate between buyers and fishers to make PC connections
  if any? buyers [
    if initconfigpccoops = "pc trans" OR initconfigpccoops = "mixed evolving" OR initconfigpccoops = "pc evolving" OR initconfigpccoops = "pc" OR initconfigpccoops = "mixed"[
      if ((ticks - 3) mod 15 = 0)[ ; can't select new ones all the time, only at t = 15, 45, 75, 105, 135 ...
        let buyersneedingfishers buyers with [ ( buyerdemand - sum [ fishedcatch ] of link-neighbors with [breed = fishers] ) > 0]
        ;type "buyersneedingfishers" show buyersneedingfishers
        ;type "buyers demand" show  [buyerdemand] of buyers
        ;type "fished catch of buyer" show [ sum [ fishedcatch ] of link-neighbors with [breed = fishers]] of buyers
        if count buyersneedingfishers > 0 [
          ifelse ticks mod 2 != 0 [ ; odd iteration
            ask buyersneedingfishers [
              buyer-select-fisher nobody
            ]
          ]
          [ ;else fishers select buyers
            let freefishers fishers with [coopid = 0 AND primarybuyer = 0]
            ask n-of min_ count buyersneedingfishers count freefishers freefishers [  ; ask x fishers to chose a buyers
              fisher-select-buyer-from-given-set ( turtle-set one-of buyersneedingfishers )  ;ask current fisher to select a buyer
              ask [primarybuyer] of self [ ; remove the buyer from the set
                set buyersneedingfishers other buyersneedingfishers
              ]
            ]
          ]
        ]
      ]
    ]
  ]


  if  (initconfigpccoops != "mixed fixed")  AND (initconfigpccoops != "pc fixed") AND (initconfigpccoops != "coops fixed") [
    if (ticks mod 15 = 0) [
      coop-de-select-fishers
    ]
    if ((ticks - 3) mod 15 = 0) [
      coop-select-fishers
    ]
  ]

  set totaleffort 0
  ask buyers [
    set fleetcatch 0 ; reset fleetcatch
    set revenue 0
  ]

  set timewithbuyer-list []

  ask fishers [
    set fishedcatch 0
    set revenue 0

    if (primarybuyer != 0 AND primarybuyer != nobody) OR (primarywholesaler != 0 AND primarywholesaler != nobody) [
      if (stayin = 0) [ ; in coops not all fishers go fish, some handle ice and management
        fishers-get-loan
        fishers-go-fish
      ]
    ]
  ]


  update-stock               ;; update fish stock after all fishing has taken place

  ask fishers with [(primarybuyer != 0 OR primarywholesaler != 0) AND stayin = 0 ] [
    fisher-cheat  ;sohuld fisher cheat?
  ]

 ; set extra catch to secondary buyer if he is a fishers so that he can sell his extra catch
  ask fishers with [secondarybuyer != 0 AND secondarybuyer != nobody] [
    if is-fisher? secondarybuyer [
      ask secondarybuyer [ set fishedcatch  fishedcatch + [fishedcatch] of myself]
    ]
  ]

  ask fishers with [(primarybuyer != 0 OR primarywholesaler != 0 ) AND stayin = 0] [
    fishers-sell-catch-and-cheating
    fishers-sell-catch  ;; sell fish i.e. calculate revenue and new capital (PC + COOP fishers)
    fishers-payback-loan
  ]

  ask buyers [
    buyers-trade                    ;; sell landings from fishermen to market
    if capital < buyermincapital [
      buyer-turn-actor
    ]
  ]

  ask fishers with [primarybuyer != 0 OR primarywholesaler != 0 ] [
    ;spend-capital
    update-loyalty
  ]

  coop-dissolve (0)
  coop-and-PC-conflict
  ask fishers with [ coopid > 0 ] [
    set coopfishermarketdemand coopfishersmarketshare * marketdemand
  ]

  if do-layout = true [
    layout
  ]

  ask businesses [
    set timesteps timesteps + 1                 ;; increase time of successful interactions between coop and wholesaler
  ]

  ask fishers [ ; make sure nobody is not used
    if primarybuyer = nobody [
      set primarybuyer  0
    ]
    if secondarybuyer = nobody [
      set secondarybuyer  0
    ]
    if primarywholesaler = nobody [
      set primarywholesaler  0
    ]
  ]

  ask turtles [ set timestepsalive timestepsalive + 1 ]

  update-globals
  update-lorenz-and-gini ; note - uses globals
  save-data

  ask fishers [
    set secondarybuyer 0 ; reset that they cheated
  ]

  tick

  if ticks = steps [
    ; save the coops and Pcs that are alive to the "Life" file
    ask buyers [
      let ts-alive timestepsalive
      save-data-lifespan-exitreason ts-alive 1 7 ;[timesteps-alive organization_type exit_reason]
    ]

    foreach list-taken-coop-ids [ [?1] ->
      let my-coopset fishers with [ coopid = ?1 ]
      let coop_tsalive [timewithcoop] of one-of my-coopset
      save-data-lifespan-exitreason coop_tsalive 2 7 ;[timesteps-alive organization_type exit_reason]
    ]
    stop
  ]

end

;;  ---------------------- PROCEDURES  ----------------------


to update-marketdemand

  if (ticks >= change-market-demand AND ticks mod 7 = 0) [

    if marketdemandtype = "lowvar" [
      set marketdemand max_ 0 ( min_ 2 ( marketdemandMSY * ((random-normal 1 0.05)) ) )
    ]

    if marketdemandtype = "medvar" [
      set marketdemand max_ 0 ( min_ 2 ( marketdemandMSY * ((random-normal 1 0.2)) ) )
    ]

    if marketdemandtype = "highvar" [
      set marketdemand max_ 0 ( min_ 2 ( marketdemandMSY * ((random-normal 1 0.5)) ) )
    ]

    if marketdemandtype = "lowlinear" [
      set marketdemand marketdemandMSY * (random-float 0.05 + 0.975)
    ]
    if marketdemandtype = "medlinear" [
      set marketdemand marketdemandMSY * (random-float 0.2 + 0.9)
    ]

    if marketdemandtype = "highlinear" [
      set marketdemand marketdemandMSY * (random-float 10)
    ]

    if marketdemandtype = "medvarskewedup" [
      ;  set marketdemand max_ 0 min_ 2 marketdemandMSY * ((random-float 0.5 + 1.2))
      set marketdemand  marketdemandMSY * 10
    ]

    if marketdemandtype = "medvarskeweddown" [
      ;set marketdemand max_ 0 min_ 2 marketdemandMSY * ((random-float 0.5 + 0.5))
      set marketdemand marketdemandMSY * 5
    ]
  ]
end


to set-amount-go-negative
  if amountgonegativetype = "eq"[
    set amountgonegative 0
  ]
  if amountgonegativetype = "low"[
    set amountgonegative -100
  ]
    if amountgonegativetype = "med"[
    set amountgonegative -1000
  ]
      if amountgonegativetype = "high"[
    set amountgonegative -10000
  ]
end

to set-cooployaltygrowthrate
  if cooployaltygrowthratetype = "slow"[
    set cooployaltygrowthrate 0.25
  ]
  if cooployaltygrowthratetype = "half"[
    set cooployaltygrowthrate 0.5
  ]
  if cooployaltygrowthratetype = "high"[
    set cooployaltygrowthrate 0.6
  ]
  if cooployaltygrowthratetype = "aspc"[
    set cooployaltygrowthrate 1.0
  ]
end



to set-marketprice

  if marketpricetype  = "eq" OR marketpricetype = "rand" OR  marketpricetype = "stock" [ ; if rand or stock then change dynamically in update-marketprice keep calibrated marketprice for the initial settings
    set marketprice marketpriceEQ
  ]

  if marketpricetype = "increase" [ ; this increases the price they get so they gain money when stock is at MSY, not +- 0 as in calibration
    set marketprice marketpriceEQ * marketpriceincrate
  ]
end

to coop-transforms


    if (ticks > 364 AND (ticks mod 365 = 0) AND num-coops-transformed < max-num-coops-to-transform) [

      ; number of co-ops to form
      let num_to_turn min_ (max-num-coops-to-transform - num-coops-transformed) coops-per-push ; max 10 can turn, but only x at a time
      repeat num_to_turn [
        ;; for a new coop
        coop-forms
      ]
    ]

end


to coop-do-intervention

    ; INITIAL INTERVETIONS do transformation for the NEW co-ops
    if intervention-initial != "none" [

      ask fishers with [ coopid > 0 AND timewithcoop = 0] [

        if ( intervention-initial = "cap"  OR intervention-initial = "cap+loy") [
          set subs_cap_tot subs_cap_tot + subs-cap-initial ; global counter
          set coopcapital coopcapital + subs-cap-initial
          set subs_cap_tot_part subs_cap_tot_part + (subs-cap-initial / subs-cap_part_unit ) ; max 1
          ;type "subs_cap_tot_part" show subs_cap_tot_part
          ;show coopcapital
        ]

        if (intervention-initial = "loy"  OR intervention-initial = "cap+loy" ) [
          set subs_loy_tot subs_loy_tot + subs-loy-initial
          set loyalty loyalty + subs-loy-initial
          set subs_loy_tot_part subs_loy_tot_part +  (subs-loy-initial / subs-loy_part_unit ) ; max 1
          ;type "subs-loy-initial" type subs-loy-initial type " coop loyalty after"
          ;show loyalty
        ]
      ]
    ; Fixed frequency INTERVENTION
    if intervention-signal = "fixed freq" AND intervention-freq > 0 [

      if (ticks - 365 ) mod ( round (intervention-freq * 30.4 )) = 0 AND ticks > 1  [
        ask fishers with [ coopid > 0 ] [

          if timewithcoop >= ( 30 ) AND timewithcoop <= (stop-sub-after-years * 365 ) [ ; dont give subs until the coop has been alive for one month
            if intervention-freq-type = "cap" OR intervention-freq-type = "cap+loy" [

              let subsamntcap subs-cap
              if coopcapital > 0 AND  coopcapital + subs-cap > maxcapitalcoopcapital [; xxxAND cap-capital = TRUE [
                set subsamntcap max_ 0 ( maxcapitalcoopcapital - coopcapital)
              ]

              if ticks > 1000000 [
               type "subsamntcap " show subsamntcap
               type "ubs-cap " show subs-cap
               type "maxcapitalcoopcapital - coopcapital" show maxcapitalcoopcapital - coopcapital
               type "maxcapitalcoopcapital" show maxcapitalcoopcapital
               type "coopcapital" show coopcapital
              ]

              set coopcapital coopcapital + subsamntcap
              set subs_cap_tot subs_cap_tot + subsamntcap
              set subs_cap_tot_part  subs_cap_tot_part +  ( subsamntcap / subs-cap_part_unit)
            ]
            if intervention-freq-type = "loy" OR intervention-freq-type = "cap+loy" [
                let subsamntloy subs-loy
                if loyalty > 0 AND loyalty + subs-loy > maxcoopmemberloyalty [; xxxAND cap-loyalty = TRUE [
                  set subsamntloy max_ 0 ( maxcoopmemberloyalty - loyalty )
                ]
                set loyalty loyalty + subsamntloy
                set subs_loy_tot subs_loy_tot + subsamntloy
                 set subs_loy_tot_part  subs_loy_tot_part +  ( subsamntloy / subs-loy_part_unit)
               ; type "------" type "loyalty " show loyalty
               ; type "max to subs-loy" show subs-loy
               ; type "subsamntloy " show subsamntloy
               ; type "subs_loy_tot " show subs_loy_tot
              ]

          ]
        ]

   ; type "subs_cap_tot_part = " show subs_cap_tot_part
    ; type "subs_loy_tot_part = " show subs_loy_tot_part

      ]
    ]


    if  (intervention-signal = "loyalty low" OR intervention-signal = "capital low" OR intervention-signal = "cap+loy low" OR intervention-signal = "cap+loy extra low")  [
      type "signal -----------------------------------------"
      foreach list-taken-coop-ids [ [?1] ->
        let my-coopset fishers with [ coopid = ?1 ]
        let subavailable [ subs_available ] of one-of my-coopset
        if ( subavailable  <= ticks AND subavailable > 0) [ ; 0 means no sub should be given
                                                            ; type "before  subavailable " show subavailable

          let cooployalty sum  [ loyalty ] of my-coopset
          let coopcap [ capital ] of one-of my-coopset  ; capital is averaged out

          let need-cap_intervention FALSE
          let need-loy_intervention FALSE
          if cooployalty < loyalty-lower-limit-signal AND ( intervention-signal = "loyalty low" OR intervention-signal = "cap+loy low" OR intervention-signal = "cap+loy extra low") [
            set need-loy_intervention TRUE
          ]
          if coopcap < capital-lower-limit-signal AND ( intervention-signal = "capital low" OR intervention-signal = "cap+loy low" OR intervention-signal = "cap+loy extra low") [
            set need-cap_intervention TRUE
          ]
          ; here START HERE need to fix that they can only get help within a certain interval
          if need-cap_intervention = TRUE OR need-loy_intervention = TRUE [
            ask my-coopset [
              if (intervention-freq-type = "loy" OR intervention-freq-type = "cap+loy" ) AND need-loy_intervention = TRUE [
                let subsamntloy subs-loy
                if loyalty + subs-loy > maxcoopmemberloyalty [
                  set subsamntloy max_ 0 ( maxcoopmemberloyalty - loyalty )
                ]
                set loyalty loyalty + subsamntloy
                set subs_loy_tot subs_loy_tot + subsamntloy
              ]
              if (intervention-freq-type = "cap" OR intervention-freq-type = "cap+loy") AND need-cap_intervention = TRUE  [
                let subsamntcap subs-cap ; amount
                let part_subs_cap 0 ; relative amount
                if  coopcapital + subs-cap > maxcapitalcoopcapital [
                  set subsamntcap max_ 0 ( maxcapitalcoopcapital - coopcapital )
                  set part_subs_cap subsamntcap / subs-cap ; calculate relative amount
                ]
                set coopcapital coopcapital + subsamntcap ; add amount to coop

                set subs_cap_tot subs_cap_tot + subsamntcap ; update total part subsudized capital
                set subs_cap_tot_part subs_cap_tot_part + part_subs_cap ; update total part subsudized capital
              ]
              update-intervention-available ; update timestep for available subsidie according to frequency
                                            ;  type ticks  type ", name " type [coopname] of one-of my-coopset type " coopid " type ? show ", intervention-signal = loyalty low "
            ]
          ]
        ]
      ]
    ]


  ]


end


to update-globals
  ;set num-pc-cheaters  num-pc-cheaters + count fishers with [coopid = 0 AND secondarybuyer != 0 ]
 set num-pc-cheaters   count fishers with [coopid = 0 AND secondarybuyer != 0 ]
 ;type "pc cheaters " show count fishers with [coopid = 0 AND secondarybuyer != 0 ]

;  set num-coop-cheaters  num-coop-cheaters + count fishers with [coopid > 0 AND secondarybuyer != 0 ]
  set num-coop-cheaters count fishers with [coopid > 0 AND secondarybuyer != 0 ]

;  type "coop cheaters " show count fishers with [coopid > 0 AND secondarybuyer != 0 ]

; type "num-pc-cheaters: " type num-pc-cheaters  type "num-coop-cheaters: " show num-coop-cheaters
  set active-pc-fishers       fishers with [coopid = 0 AND primarybuyer != 0]
  set active-coop-fishers     fishers with [coopid > 0 AND primarywholesaler != 0]
  set active-fishers          (turtle-set  active-pc-fishers active-coop-fishers)

  set inactive-fishers        (turtle-set fishers with [coopid = 0 AND primarybuyer = 0 ] fishers with [coopid > 0 AND primarywholesaler = 0])
  set num-active-pc-fishers   count active-pc-fishers
  set num-active-coop-fishers count active-coop-fishers
  set num-active-fishers      count active-fishers
  set num-inactive-fishers    count inactive-fishers
  set num-buyers              count buyers
  set num-coops               length list-taken-coop-ids

  ifelse num-active-fishers > 0 [
    set active-fishers-loyalty ( sum [loyalty] of active-fishers ) / num-active-fishers
  ]
  [
     set active-fishers-loyalty 0
  ]

  ifelse num-active-coop-fishers > 0 [
    set active-coop-fishers-capital ( sum [capital]     of active-coop-fishers ) / num-active-coop-fishers
    set coop-fishers-coop-capital   ( sum [coopcapital] of active-coop-fishers ) / num-active-coop-fishers
    set active-coop-fishers-loyalty ( sum [loyalty]     of active-coop-fishers ) / num-active-coop-fishers
    set ind-capital-coop [capital] of active-coop-fishers
  ]
  [
    set active-coop-fishers-capital 0
    set coop-fishers-coop-capital   0
    set active-coop-fishers-loyalty 0
    set ind-capital-coop 0
  ]
  ifelse num-active-pc-fishers > 0 [
    set active-pc-fishers-capital   ( sum [capital]     of active-pc-fishers ) / num-active-pc-fishers
    set active-pc-fishers-loyalty   ( sum [loyalty]     of active-pc-fishers ) / num-active-pc-fishers
    set ind-capital-pc [capital] of active-pc-fishers
  ]
  [
     set active-pc-fishers-capital 0
    set active-pc-fishers-loyalty 0
    set ind-capital-pc 0
  ]
  ifelse num-buyers > 0 [
    set active-buyers-capital       ( sum [capital]     of buyers ) / num-buyers
    set ind-capital-buyers [capital] of buyers
    set buyers-credits       ( sum [credits] of buyers ) / num-buyers
  ]
  [
    set active-buyers-capital 0
    set ind-capital-buyers 0
    set buyers-credits 0
  ]
  ifelse num-inactive-fishers > 0 [
    set inactive-fishers-capital       ( sum [capital]     of inactive-fishers ) / num-inactive-fishers
  ]
  [
    set inactive-fishers-capital 0
  ]

end

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; save data
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;


to save-data-lifespan-exitreason [timesteps-alive organization_type exit_reason]
if ticks > 1 AND write-on = true
[

  file-open (filenameLife)     ; save numeric
  file-write runs                  ; the current seed
  file-write ticks                  ; if tick = 36500 then they are still alive
  file-write timesteps-alive
  file-write organization_type     ; pc or co-op 1 or 2
  file-write exit_reason           ; 4  capital 5 is loyalty 6 is size
  file-write precision stock 10
  file-write reliabilitytype
  file-write initialloyaltytype
  file-write intervention-initial
  file-write intervention-freq
  file-write marketdemandtype
  file-write coops-per-push
  file-write subs-cap
  file-write subs-loy
  file-write stop-sub-after-years
  file-write "dummy2"
  file-write "dummy3"
  file-write "dummy4"
  file-write "dummy5" ; to be able to rerun new files ones dummies are filled
  file-print " "
  file-close-all

]
end




to save-data

  if write-on = true [
    if ticks >= beginfilewriting [
      if ticks = beginfilewriting AND runs = 1 [ ; no need to save this evey time
        file-open (filenameStr) ; Save strings / settings
        file-write "reliabilitytype"
        file-write reliabilitytype
        file-write "managerialskillstype"
        file-write managerialskillstype
        file-write "fishingskillstype"
        file-write fishingskillstype
        file-write "x"
        file-write 0
        file-write "socialskillstype"
        file-write socialskillstype
        file-write "initconfigpccoops"
        file-write initconfigpccoops
        file-write "initialcapitaltype"
        file-write initialcapitaltype
        file-write "maxcapitalbuyer"
        file-write maxcapitalbuyer
        file-write "amountgonegative"
        file-write amountgonegative
        file-write "intervalforentering"
        file-write intervalforentering
        file-write "ecosystemdynamicstype"
        file-write ecosystemdynamicstype
        file-write "marketpricetype"
        file-write marketpricetype
        file-write "initialactors"
        file-write initialactors
        file-write "intervalforentering"
        file-write intervalforentering
        file-write "amountgonegative"
        file-write amountgonegative
        file-write "initialloyaltyvalue"
        file-write initialloyaltyvalue
        file-write "initialloyaltytype"
        file-write initialloyaltytype
        file-write "ecosystemdynamicstype"
        file-write ecosystemdynamicstype
        file-write "reliabilitytype"
        file-write reliabilitytype
        file-write "catchability-var"
        file-write catchability-var
        file-write "cooployaltygrowthrate"
        file-write cooployaltygrowthrate
        file-write "reliabilityvariance"
        file-write reliabilityvariance
        file-write "initialcapitalvariance"
        file-write initialcapitalvariance
        file-write "initialloyaltySD"
        file-write initialloyaltySD
        file-write "marketdemandtype"
        file-write marketdemandtype
        file-write "coops-per-push"
        file-write coops-per-push
        file-write "x"
        file-write 0
        file-write "cap-loyalty"
        file-write 0
        file-write "cap-capital"
        file-write 0
        file-write "maxcapitalfisher-m"
        file-write -1
        file-write "maxcapitalbuyer-m"
        file-write -1
        file-write "marketpricetype"
        file-write marketpricetype
        file-write "marketpriceincrate"
        file-write marketpriceincrate
        file-write "socialdisturbancetype"
        file-write socialdisturbancetype
        file-write "stop-sub-after-years"
        file-write stop-sub-after-years
        file-write "x3"
        file-write -1
        file-write "x4"
        file-write -1
        file-write "x5"
        file-write -1
        file-write "x6"
        file-write -1


        file-write ticks
        file-print " "
        file-close-all
      ]
      if ticks mod save_interval = 0 [

        file-open (filenameNum) ; save numeric
        file-write runs
        file-write stock

        file-write reliabilityvalue
        ; counts
        file-write num-buyers
        file-write num-coops


        file-write num-active-fishers
        file-write num-active-pc-fishers
        file-write num-active-coop-fishers
        ; capital
        file-write active-pc-fishers-capital
        file-write active-coop-fishers-capital
        file-write active-buyers-capital
        file-write coop-fishers-coop-capital
        ; loyalty
        file-write active-fishers-loyalty
        file-write active-coop-fishers-loyalty
        file-write active-pc-fishers-loyalty
        ; other

        let the_accumulatedloyalty initialloyaltyvalue
        if (num-active-fishers > 0) [ ; removed: AND (reliabilitytype != "fixed" AND reliabilitytype != "eq") accumulated is accumulated right?
          set the_accumulatedloyalty sum ( [ loyalty ] of active-fishers ) / num-active-fishers
        ]

        file-write the_accumulatedloyalty


        file-write inactive-fishers-capital
        file-write buyers-credits
        ; GINI and lorentz pts
        file-write gini-index-reserve-final
        file-write gini-index-reserve-pc-final
        file-write gini-index-reserve-coop-final

        ; all settings with variable conditions are calculated and saved as below
        ; but when running eg fixed eman we rund fs with mean 0.2 0.3 0.4 then in R we need to distinguish between the mean and what the active fishers have.
        ; we save the actual mean here and then save the average in the pc_fishingskills and the coo_fishingskills
        file-write fishingskillsvalue
        ;; Exit reasons
        file-write num-coop-fishers-exit-loyalty
        file-write num-pc-fishers-exit-buyer
        file-write num-coop-fishers-exit-capital
        file-write num-coop-fishers-exit-size
        file-write num-buyers-exit-capital
        file-write num-coops-dissolve-capital
        file-write num-coops-dissolve-size
        file-write num-coops-dissolve-loyalty
        ;; cheaters
        file-write num-coop-cheaters
        file-write num-pc-cheaters
        ifelse num-buyers > 0 [
          file-write sum [price] of buyers / num-buyers
        ]
        [
          file-write 0
        ]
        file-write marketprice
        file-write ticks

        ; START save actor attributes per coops and pc
        ; PC
        let pc_reliabilityvalue reliabilityvalue ; fixed

        ;; calculate average
        if (num-active-pc-fishers > 0 AND (reliabilitytype != "fixed" AND reliabilitytype != "eq cheating" AND reliabilitytype != "eq no cheating")) [
          set pc_reliabilityvalue sum ( [ reliability ] of active-pc-fishers ) / num-active-pc-fishers
          ;type "pc " type pc_reliabilityvalue show  [ reliability ] of active-pc-fishers
        ]
       ; show precision pc_reliabilityvalue 10
        file-write precision pc_reliabilityvalue 10

        let coop_reliabilityvalue reliabilityvalue
        ; calculate average for all cases that are not fixed
        if (num-active-coop-fishers > 0 AND (reliabilitytype != "fixed" AND reliabilitytype != "eq cheating" AND reliabilitytype != "eq no cheating")) [
          set coop_reliabilityvalue sum ( [ reliability ] of active-coop-fishers ) / num-active-coop-fishers
          ;type "coop " type coop_reliabilityvalue show  [ reliability ] of active-coop-fishers
        ]
        file-write precision coop_reliabilityvalue 10

        let pc_fishingskillsvalue fishingskillsvalue
        ; calculate average if varied fishingskills
        if (num-active-pc-fishers > 0  AND (fishingskillstype != "fixed" AND fishingskillstype != "eq")) [
          set pc_fishingskillsvalue sum ( [ fishingskills ] of active-pc-fishers ) / num-active-pc-fishers
        ]
        file-write precision pc_fishingskillsvalue 10

        let coop_fishingskillsvalue fishingskillsvalue
        if (num-active-coop-fishers > 0  AND (fishingskillstype != "fixed" AND fishingskillstype != "eq")) [
          set coop_fishingskillsvalue sum ( [ fishingskills ] of active-coop-fishers ) / num-active-coop-fishers
        ]
        file-write precision coop_fishingskillsvalue 10

        ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
        ;;  save reliability values for those who have been active more than a year to get rid of noice
        let pc_reliabilityvalue_lifespan reliabilityvalue ; fixed

        ;; calculate average
        if (num-active-pc-fishers > 0 AND (reliabilitytype != "fixed" AND reliabilitytype != "eq cheating" AND reliabilitytype != "eq no cheating")) [
          set pc_reliabilityvalue_lifespan sum ( [ reliability ] of active-pc-fishers with [timestepsalive > 365]) / num-active-pc-fishers

        ]
       ; show precision pc_reliabilityvalue 10
        file-write precision pc_reliabilityvalue_lifespan 10

        let coop_reliabilityvalue_lifespan reliabilityvalue
        ; calculate average for all cases that are not fixed
        if (num-active-coop-fishers > 0 AND (reliabilitytype != "fixed" AND reliabilitytype != "eq cheating" AND reliabilitytype != "eq no cheating")) [
          set coop_reliabilityvalue_lifespan sum ( [ reliability ] of active-coop-fishers with [timestepsalive > 365] ) / num-active-coop-fishers

        ]
        file-write precision coop_reliabilityvalue_lifespan 10
        file-write precision marketdemand 3

        file-write intervention-initial
        file-write subs-cap
        file-write subs-loy
        file-write intervention-signal
        file-write intervention-freq
        file-write intervention-freq-type

        file-write 0 ; dummy for R dont remove!!
        file-write subs_cap_tot
        file-write subs_loy_tot
        file-write coops-per-push
        file-write stop-sub-after-years
        file-write subs_cap_tot_part
        file-write subs_loy_tot_part
        file-write intervention-matching
        file-write loy-reduction-level
        file-write conflict-type
        file-write initialloyaltyvalue
        file-write initialcapitalvalue
        file-write 0
        file-write 0
        file-write 0 ; makes it able to rerun old files when this is used in the future
        ; END save actor attributes per coops and pc
        file-print " "
        file-close-all
      ]
    ]
  ]
end

to set-initialloyalty [the-coop-set]

  ;let eq_loyalty 30; 21
  let eq_loyalty 40; ;40 if varied 30 if fixed
  let the_loyalty eq_loyalty; 21

  let variation initialloyaltySD

  let low_mean 5
  let low_variance variation

  let med_mean eq_loyalty
  let med_variance variation

  let high_mean 100
  let high_variance variation

  if initialloyaltytype = "eq" [
    set the_loyalty eq_loyalty
    set initialloyaltySD 0
  ]
   if initialloyaltytype = "365" [
    set the_loyalty 366
  ]
  if initialloyaltytype = "0" [
    set the_loyalty 0
  ]
  if initialloyaltytype = "low" [
    ;linear let a 1 let b 20 set the_loyalty rand b + a  ; rand 1-20
    set the_loyalty max_ 0 ( random-normal low_mean low_variance )
  ]
  if initialloyaltytype = "med" [
    ; let a 10 let b 21 set the_loyalty random b + a  ; rand 0-20 + 10, 10-30
    set the_loyalty max_ 0 ( random-normal med_mean med_variance )
  ]
  if initialloyaltytype = "high" [
    ; let a 20 let b 21 set the_loyalty random b + a  ;; random 0-20 + 20-39
    set the_loyalty max_ 0 ( random-normal high_mean high_variance )
  ]
  if initialloyaltytype = "fixed" [
    set the_loyalty initialloyaltyvalue
    set initialloyaltySD 0
  ]
  if initialloyaltytype = "fixedvar" [
    set the_loyalty max_ 0 ( random-normal initialloyaltyvalue variation )
  ]
  ask the-coop-set
  [
    set loyalty the_loyalty
  ]
end


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; update-marketprice
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

to update-marketprice


  if marketpricetype = "stock" [ ; if stock is low price goes up!
    let price_change   -1 * ( stock - MSYstock ) * marketpriceEQ / 10
    set marketprice marketprice + price_change
  ]
  ;
  if marketpricetype = "rand" [ ; if stock is low price goes up!
    set marketprice marketpriceEQ + random-normal marketpriceEQ marketpriceEQ * 0.10  ;sdandard deviation 10% of price
  ]

end


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; update-stock   fish dynamics = archetypical fish problem a la C.W. Clark ;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

to update-stock
  let changeinstock 0
  set totalcatch sum [fishedcatch] of fishers


  let coop_catch sum [fishedcatch] of active-coop-fishers
  let num_coop_fishers count active-coop-fishers
  let average-catch-per-fisher 0

  if num_coop_fishers > 0 AND intervention-signal = "catch low" [ ; this gives div by zero at some point
    set average-catch-per-fisher coop_catch / num_coop_fishers
    set list-coop-catches lput average-catch-per-fisher list-coop-catches


    if length list-coop-catches > 200 AND (ticks mod 50 = 0)[ ; start to add and removeremove first item

      let sum_old sum (sublist list-coop-catches 100 (100 + 50)) ; sum of values before last added
      let new_sum sum (sublist list-coop-catches 150 (150 + 50)) ; sum of values before last added
      let diff abs (sum_old - new_sum) / (new_sum) * 100


      set list-coop-catches but-first list-coop-catches
    ]
  ]

  if (ecosystemdynamicstype = "seasonal" OR ecosystemdynamicstype = "uncertain+seasonal") AND ticks > 1 [
    ; BAD FISHING
    if ticks mod (364 / 2) = 0 [

      set stock stock - 40
    ] ; GOOD FISHING
    if ticks mod (364) = 0 [
      set stock stock + 80

    ]
  ]

    set changeinstock growthrate * stock * ( 1 - stock / carryingcapacity )  - totalcatch; ;; account for fishing


  ifelse stock + changeinstock < 0 ;; stock cant be less than zero
    [ set stock 0 ]

    [ set stock stock + changeinstock
       ]
end

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; update-lorenz-and-gini this procedure recomputes the value of gini-index-reserve
;; and the points in lorenz-points for the Lorenz and Gini-Index plots
;; new  version calculate gini per coop, ie loop though coops and calc GINI as below then take average gini/numfishers in coops
;; new version pc fishers, take each buyer and its attached fishers and calcualte GINI per PC-setting then take sum of GINI / fishers in PC + buyers
;; coummunity?
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

to update-lorenz-and-gini
    if ticks mod 365 = 0 AND ticks > 0 [
  let community-set (turtle-set active-fishers buyers)
;  let pc-set  (turtle-set active-pc-fishers buyers)


  let gini-index-reserve 0
  let gini-index-reserve-pc 0
  let gini-index-reserve-coop 0
  set gini-index-reserve-final 0
  set gini-index-reserve-pc-final 0
  set gini-index-reserve-coop-final 0

  ;; COMMUNITY
  ;; do loop around this wone and let num-people be num in coop, i.e set community-set to each coop
  ;; then save and aftr do average

  let num-people count community-set
  let sorted-wealths-tmp sort [capital ] of community-set
  let min-cap  [capital ] of min-one-of community-set  [capital ]
  if min-cap > 0 [
    set min-cap 0
  ]
  let sorted-wealths (map  [ [?1] -> abs (min-cap) + ?1 ] sorted-wealths-tmp)
  let total-wealth sum sorted-wealths
  let wealth-sum-so-far 0
  let index 0
  set lorenz-points []
  if num-people > 1 AND total-wealth > 0 [
    repeat num-people [
      set wealth-sum-so-far (wealth-sum-so-far + item index sorted-wealths)
      set lorenz-points lput ((wealth-sum-so-far / total-wealth) * 100) lorenz-points
      set index (index + 1)
      set gini-index-reserve gini-index-reserve + (index / num-people) -   (wealth-sum-so-far / total-wealth)
    ]
    set gini-index-reserve-final (gini-index-reserve / num-people) / 0.5
  ]
  ;; PC
  let gini-index-reserve-pc-final-tmp 0
  let pc-counter 0
  ask buyers [
    if any? my-partnerships [

      if timestepsalive > 2 * 365 [ ; must have been alive more than 2 years to be counted [
        set pc-counter pc-counter + 1
        let pc-set ( turtle-set link-neighbors with [breed = fishers] self ) ; fishers and their buyer
                                                                             ;  timewithbuyer
                                                                             ;   set currentsupply sum [fishedcatch] of link-neighbors with [breed = fishers]
        set gini-index-reserve-pc 0
        set num-people count pc-set
        set sorted-wealths 0
        set sorted-wealths-tmp sort [capital ] of pc-set
        set min-cap  [capital ] of min-one-of pc-set  [capital ]
        if min-cap > 0 [
          set min-cap 0
        ]
        set sorted-wealths (map  [ [?1] -> abs (min-cap) + ?1 ] sorted-wealths-tmp)
        set total-wealth sum sorted-wealths
        set wealth-sum-so-far 0
        set index 0
        let lorenz-points-pc []
        if num-people > 1 AND total-wealth > 0 [
          repeat num-people [
            set wealth-sum-so-far (wealth-sum-so-far + item index sorted-wealths)
            set lorenz-points-pc lput ((wealth-sum-so-far / total-wealth) * 100) lorenz-points-pc
            set index (index + 1)
            set gini-index-reserve-pc gini-index-reserve-pc + (index / num-people) -   (wealth-sum-so-far / total-wealth)
          ]
          set gini-index-reserve-pc-final-tmp gini-index-reserve-pc-final-tmp + (gini-index-reserve-pc / num-people) / 0.5
        ]
      ]
    ]
  ]
  ifelse pc-counter > 0 [
    set gini-index-reserve-pc-final gini-index-reserve-pc-final-tmp /  pc-counter
  ]
  [
    set gini-index-reserve-pc-final 0
  ]

  ;; COOP
  let gini-index-reserve-coop-final-tmp 0
  let coop-counter 0
  foreach  list-taken-coop-ids [ [?1] ->
    let coop-set fishers with [ coopid = ?1 ]
    let coop-memb min-one-of coop-set [ timewithcoop]

    if coop-memb != NOBODY [
      if [ timewithcoop] of coop-memb > 2 * 365 [ ; must have been alive more than 2 years to be counted [
        set coop-counter coop-counter + 1
        set num-people      count coop-set
        set sorted-wealths 0
        set sorted-wealths-tmp sort [capital ] of coop-set
        set min-cap  [capital ] of min-one-of coop-set  [capital ]
        if min-cap > 0 [
          set min-cap 0
        ]
        set sorted-wealths (map  [ [??1] -> abs (min-cap) + ??1 ] sorted-wealths-tmp)



        set total-wealth sum sorted-wealths
        set wealth-sum-so-far 0
        set index 0
        set gini-index-reserve-coop 0
        let lorenz-points-coop []
        if num-people > 1 AND total-wealth > 0 [
          repeat num-people [
            set wealth-sum-so-far (wealth-sum-so-far  + item index sorted-wealths)
            set lorenz-points-coop lput ((wealth-sum-so-far / total-wealth) * 100) lorenz-points-coop
            set index (index + 1)
            set gini-index-reserve-coop gini-index-reserve-coop + (index / num-people) -   (wealth-sum-so-far / total-wealth)
          ]
          set gini-index-reserve-coop-final-tmp gini-index-reserve-coop-final-tmp + (gini-index-reserve-coop / num-people) / 0.5
        ]
      ]
    ]
  ]

  ifelse coop-counter > 0 [
    set gini-index-reserve-coop-final gini-index-reserve-coop-final-tmp /  coop-counter
  ]
  [
    set gini-index-reserve-coop-final 0
  ]
    ]
end



to plot-list [input]
  (foreach input (n-values length input [ [?1] -> ?1 ])
    [ [?1 ?2] -> create-temporary-plot-pen (word ?2)
      set-plot-pen-color green ;10 * ?2 + 2 * int(?2 / 14) + 3
      set-plot-pen-mode 2 ;0 linw 1 histo 2 point

      plotxy ticks ?1 ])
end

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; set-shares-demand-price   set for new buyer
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;


to setup-buyers-shares-demand-price


  if buyermarketshare = 0  [; only do this for new buyer without shares
    ;set unreliablefishers-set n-of 0 fishers ; initiate empty list
    set buyermarketshare groupsizeEQ / MSYfishers; random-float 1 / 3 ; remove randomness random-normal 0.2 0.1
    set buyerdemand buyermarketshare * marketdemand
    set price marketprice * fisherspriceproportionEQ ;* random-normal 1 0.1 * 0.01. price = marketprice * 0.8 calibrated

  ]
end


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; setup-fishers-buyers-coops
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
to setup-fishers-buyers-coops
  let tmp_individualeffort (( growthrateEQ / 2 ) /  MSYfishers ) * 1 * decrease_individualeffort
  create-actors round ( initialactors / 3 ) [  ;; actor sets all attributes and they are taken with each time an agent changes type
    setxy random-xcor random-ycor
    set color orange
    set size 1
    set shape "person"
    set-initialcapital
    set individualeffort  tmp_individualeffort

    set-socialskills
    set-managerialskills
    set-fishingskills
    set-reliability
    set reputation fishingskills * reliability
    set clanid 1

  ]

  create-actors round ( initialactors / 3 ) [  ;; actor sets all attributes and they are taken with each time an agent changes type
    setxy random-xcor random-ycor
    set color orange
    set size 1
    set shape "person"
    set-initialcapital
    set individualeffort tmp_individualeffort

    set-socialskills
    set-managerialskills
    set-fishingskills
    set-reliability
    set reputation fishingskills * reliability
    set clanid 2
  ]

  create-actors ceiling ( initialactors / 3 ) [  ;; actor sets all attributes and they are taken with each time an agent changes type
    setxy random-xcor random-ycor
    set color orange
    set size 1
    set shape "person"
    set-initialcapital
    set individualeffort tmp_individualeffort

    set-managerialskills
    set-fishingskills
    set-socialskills
    set-reliability
    set reputation fishingskills * reliability
    set clanid 3
  ]

  ask actors [
    ;type "before ask actors turn fisher" show capital
    actor-turn-fisher
  ]

  ;; set up initial buyers and coops for fixed scenarios
  if initconfigpccoops = "pc fixed" OR initconfigpccoops = "pc" OR initconfigpccoops = "pc trans" [
    let numtosetup round ( MSYfishers / groupsizeEQ )
    select-fisher-turn-buyer numtosetup
    ask buyers [
      setup-buyers-shares-demand-price
      repeat groupsizeEQ [
        ;show count my-partnerships
        if count my-partnerships < groupsizeEQ [
          buyer-select-fisher nobody
        ]
      ]
    ]

    if initconfigpccoops = "pc trans" [
      set intervalforcoopentering round (365 * intervalforentering * 1000) ; will not happen, coops do not enter normally we use transform function instead
      ; special case

      if coops_continue_entering = TRUE
      [
        set intervalforcoopentering round (365 * intervalforentering )
      ]
    ]
  ]

  ;type "count buyers" show count buyers

  if initconfigpccoops = "coops fixed" OR initconfigpccoops = "coops"[
    let numtosetup round (MSYfishers / groupsizeEQ)
    repeat numtosetup [
      coop-forms
    ]
  ]

  if initconfigpccoops = "mixed fixed" OR initconfigpccoops = "mixed" [
    let numtosetup round ((MSYfishers / groupsizeEQ) / 2 )
    repeat numtosetup [
      coop-forms
    ]
    select-fisher-turn-buyer numtosetup

    ask buyers [
      setup-buyers-shares-demand-price
      repeat groupsizeEQ [
        ;show count my-partnerships
        if count my-partnerships < groupsizeEQ [
          ;  type "5 debugging " show initticks
          buyer-select-fisher nobody; 5 random fishers
        ]
      ]
    ]
  ]


  ;show [capital] of fishers
  ;show count fishers
end

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; set initial capital
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
to set-initialcapital

  if initialcapitaltype = "uniform" [
    set capital initialcapital
  ]

  if initialcapitaltype = "uniform sensitivity" [
    set capital initialcapitalvalue
  ]



  if initialcapitaltype = "variable" [
    set capital random-normal initialcapital initialcapitalvariance

    if capital < 5
      [ set capital 5 ]
  ]
  if initialcapitaltype = "normal" [
    set capital random-normal initialcapital 50
    if capital < 1
      [ set capital 1 ]
  ]
  if initialcapitaltype = "non uniform" [
    ifelse random-float 1 < 0.1 [
      set capital 1000
    ]
    [
      set capital 1
    ]
  ]
end


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; set-intervention-available
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;to set-intervention-available
;  ifelse intervention-signal != "none" OR intervention-signal != "fixed freq" [
;    set subs_available intervention-freq
;  ]
;  [ set subs_available 0 ]
;end

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; update-intervention-available
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
to update-intervention-available
  if intervention-signal != "none" AND intervention-signal != "fixed freq" [
    set subs_available ticks + round (intervention-freq * 30.4) + 1; start avalability after freq has passed from current point in time
  ]
end

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; set reliability
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
to set-reliability


  let deviate_from_eq 0.3;0.007 ;0.012 0.655
  let low_mean eq_cheating - deviate_from_eq
  let low_variance deviate_from_eq
  let med_mean  eq_cheating
  let med_variance deviate_from_eq
  let high_mean eq_cheating + deviate_from_eq
  let high_variance deviate_from_eq

  let low_variance_D 0.05
  let med_variance_D 0.3
  let high_variance_D 0.6

  let fixedvar_variance_D med_variance_D ; for sensitivity variance

  ; let a 2 * eq_cheating - 1
  ; let b 1 - a
  ; let low_diff eq_cheating - a

  if reliabilitytype = "eq no cheating" [
    set reliability eq_no_cheating
    set reliabilityvalue eq_no_cheating ; to save to R
    set reliabilityvariance 0 ; to save to R
  ]
  if reliabilitytype = "eq cheating" [
    set reliability eq_cheating
    set reliabilityvalue eq_cheating ; to save to R
    set reliabilityvariance 0 ; to save to R
  ]
  if reliabilitytype = "low" [
    set reliability min_  1 ( max_ 0  ( random-normal low_mean low_variance ))
    set reliabilityvalue low_mean ; for R
    set reliabilityvariance low_variance ; to save to R
    ;set reliability min_ 1 max_ 0 ifelse-value (random-float 1 < 0.66)
    ;[ random-normal low_mean low_variance ]
    ;[ random-normal med_mean med_variance ]

    ; linear random-float a + (eq_cheating - a)
  ]
  if reliabilitytype = "med" [
    set reliability min_  1 (max_ 0  ( random-normal med_mean med_variance ))
    set reliabilityvalue med_mean ; for R
    set reliabilityvariance med_variance ; to save to R
    ; linear random-float b + a
    ;ifelse random-float 1 < 0.33 [
     ; set reliability min_ 1 max_ 0 ifelse-value (random-float 1 < 0.5)
      ;[ random-normal low_mean low_variance ]
      ;[ random-normal high_mean high_variance ]
    ;]
    ;[
    ;  set reliability min_ 1 max_ 0 random-normal med_mean med_variance
    ;]
  ]
  if reliabilitytype = "high" [
    set reliability min_  1 (max_ 0  ( random-normal high_mean high_variance ))
    set reliabilityvalue high_mean ; for R
    set reliabilityvariance high_variance ; to save to R
    ; linear random-float (1 - eq_cheating) + eq_cheating
    ;set reliability min_ 1 max_ 0 ifelse-value (random-float 1 < 0.66)
    ;[ random-normal high_mean high_variance ]
    ;[ random-normal med_mean med_variance ]

  ]
 if reliabilitytype = "lowD" [
    set reliability min_  1 (max_ 0  ( random-normal eq_cheating low_variance_D ))
    set reliabilityvalue eq_cheating ; for R
    set reliabilityvariance low_variance_D ; to save to R
  ]
  if reliabilitytype = "medD" [
    set reliability min_  1 (max_ 0  ( random-normal eq_cheating med_variance_D ))
     set reliabilityvalue eq_cheating ; for R
     set reliabilityvariance med_variance_D ; to save to R
  ]
  if reliabilitytype = "highD" [
    set reliability min_  1 (max_ 0  ( random-normal eq_cheating high_variance_D ))
     set reliabilityvalue eq_cheating ; for R
     set reliabilityvariance high_variance_D ; to save to R
  ]
  if reliabilitytype = "fixed" [
    set reliability  reliabilityvalue
  ]
   if reliabilitytype = "fixedcom" [
    set reliability  min_  1 (max_ 0  ( random-normal eq_cheating reliabilityvariance ))
     set reliabilityvalue eq_cheating ; for R
     set reliabilityvariance reliabilityvariance ; to save to R
  ]
  if reliabilitytype = "fixedvar" [
    set reliability  min_  1 (max_ 0  ( random-normal reliabilityvalue fixedvar_variance_D ))
     set reliabilityvalue reliabilityvalue ; for R
     set reliabilityvariance fixedvar_variance_D ; to save to R
   ]
end

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; set social skills
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
to set-socialskills

  let tmpms 0.5 ;
  if socialskillstype = "eq" [
    set socialskills tmpms
  ]
  if socialskillstype = "rand 0.5 1" [
    set socialskills random-float 0.5 + 0.5
  ]
  if socialskillstype = "rand 1 1.5" [
    set socialskills random-float 0.5 + 1
  ]
end


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; set fishing skills
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
to set-fishingskills

  let fs_low_mean  0.3
  let fs_med_mean  0.5
  let fs_high_mean  0.7

  let eq_fishingskills 0.5 ; EQ
  if fishingskillstype = "eq" [
    set fishingskills eq_fishingskills
    set fishingskillsvalue eq_fishingskills ; for saving to R
  ]
  if fishingskillstype = "fixed" [
    set fishingskills fishingskillsvalue
  ]
  if fishingskillstype = "fixedmean" [
    set fishingskills  min_  1 max_ 0  ( random-normal fishingskillsvalue 0.2 )
  ]

  if fishingskillstype = "low" [
    ;; this must be > price that fisher get which is at 80% now so atleast 0.8 + cover for loan losses and daily expences
    set fishingskills min_  1 max_ 0  ( random-normal fs_low_mean 0.1 ) ;random-float 0.5 + 0.1
    set fishingskillsvalue fs_low_mean ; for saving to R
  ]

  if fishingskillstype = "med" [
    set fishingskills min_  1 max_ 0.1 ( random-normal fs_med_mean 0.3 ) ; variability 0.1 instead of 0.3 for paper 1
    set fishingskillsvalue fs_med_mean ; for saving to R
  ]

  if fishingskillstype = "high" [
    set fishingskills min_  1 max_ 0.45 ( random-normal fs_high_mean 0.1 );; this must be > price that fisher get which is at 80% now so atleast 0.8 + cover for loan losses and daily expences
    set fishingskillsvalue fs_high_mean ; for saving to R
  ]
end

to-report max_ [number1 number2]
  ifelse number1 > number2
    [ report number1 ]
    [ report number2 ]
end

to-report min_ [number1 number2]
  ifelse number1 < number2
    [ report number1 ]
    [ report number2 ]
end



;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; set managerial skills
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; managerialskills must be > price that fisher get which is at 80% (if fixed) now so atleast 0.8 + cover for loan losses and daily expences
to set-managerialskills

  let tmpms 1 ; EQmanagerialskills
  if managerialskillstype = "eq" [
    set managerialskills tmpms ; random-normal 1 0.1   ;; this must be > price that fisher get which is at 80% now so atleast 0.8 + cover for loan losses and daily expences
    set coopmanagerialskills tmpms ; random-normal 1 0.1   ;; this must be > price that fisher get which is at 80% now so atleast 0.8 + cover for loan losses and daily expences
  ]
  if managerialskillstype = "rand 0.6 1.4" [
    set managerialskills random-float 0.8 + 0.6   ;; this must be > price that fisher get which is at 80% now so atleast 0.8 + cover for loan losses and daily expences
    set coopmanagerialskills random-float 0.8 + 0.6  ;; this must be > price that fisher get which is at 80% now so atleast 0.8 + cover for loan losses and daily expences
  ]
  if managerialskillstype = "rand 0.5 1" [
    set managerialskills random-float 0.5 + 0.5   ;; this must be > price that fisher get which is at 80% now so atleast 0.8 + cover for loan losses and daily expences
    set coopmanagerialskills random-float 0.5 + 0.5   ;; this must be > price that fisher get which is at 80% now so atleast 0.8 + cover for loan losses and daily expences
  ]
  if managerialskillstype = "rand 1 1.5" [
    set managerialskills random-float 0.5 + 1   ;; this must be > price that fisher get which is at 80% now so atleast 0.8 + cover for loan losses and daily expences
    set coopmanagerialskills random-float 0.5 + 1   ;; this must be > price that fisher get which is at 80% now so atleast 0.8 + cover for loan losses and daily expences
  ]
  if managerialskillstype = "fixed" [
    set managerialskills managerialskillsvalue ; random-normal 1 0.1   ;; this must be > price that fisher get which is at 80% now so atleast 0.8 + cover for loan losses and daily expences
    set coopmanagerialskills managerialskillsvalue ; random-normal 1 0.1   ;; this must be > price that fisher get which is at 80% now so atleast 0.8 + cover for loan losses and daily expences
  ]


end

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; coop-forms
;; not constraned by demand, always fish on fixed effort and sell all their fish to the market.
;; sold vs fishedcatch is always the same.
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

to coop-forms ;[selection-rule]

  let clanset 0
  let newcoopid 0
  ;; FIND a coopid for the new coop
  if not empty? list-free-coop-ids [ ; cannot be empty because the list is longer than fishers available to form coops, but could of course change in the future

    set newcoopid first list-free-coop-ids
    ;; drop that item from the list
    set list-free-coop-ids but-first list-free-coop-ids
    ;; add to list of taken ids
    set list-taken-coop-ids fput newcoopid list-taken-coop-ids
    ;let set-of-fishers fishers with [ coopid = 0 AND ( primarybuyer = 0 OR primarybuyer = nobody ) ]

    let set-of-fishers []
    ifelse initconfigpccoops = "pc trans" [
      set set-of-fishers fishers with [ coopid = 0 AND (primarybuyer != 0 OR primarybuyer != nobody ) ]
    ]
    [
      set set-of-fishers fishers with [ coopid = 0 AND ( primarybuyer = 0 OR primarybuyer = nobody ) ]
    ]
    ;set vision to less than the whole commmunity
    set clanset n-of min_ count set-of-fishers round (initialactors / 4) set-of-fishers;
  ]

  if newcoopid > 0 [
    let coopsize groupsizeEQ;

    if count clanset with [coopid = 0] >= coopsize[
      let newcoopset n-of groupsizeEQ clanset with [coopid = 0]
      set-initialloyalty (newcoopset)
      ;; initialize the coop members parameters
      let the_name first list-free-coop-names
      set list-free-coop-names remove the_name list-free-coop-names
      ask n-of coopsize newcoopset  [
        ask my-partnerships [die]
        set primarybuyer 0
        set secondarybuyer 0
        set loan 0
        set coopid newcoopid
        set coopname the_name
        set timewithcoop 0
        set timewithbuyer 0
        set-managerialskills
        set primarywholesaler one-of wholesalers
        set price [price] of primarywholesaler ; price to give to cheating fishers
        set coopfishermarketdemand coopfishersmarketshare * marketdemand;
        set coopcapital initialcoopcapital; here give some capital to be able to start up

        ifelse initialcapitaltype = "uniform sensitivity coops" AND coopid > 0 [
          set capital initialcapitalvalue
        ]
        [  set-initialcapital ]

        update-intervention-available
        create-friendships-with other newcoopset
      ]
      set num-coops-transformed num-coops-transformed + 1
      ask one-of newcoopset [
        create-business-with one-of wholesalers ; there is only one primarywholesaler
      ]

      if print-std-out = true [
        type "coop-forms: coop-loyalty=" type sum [loyalty] of newcoopset type ", capital=" type sum [capital] of newcoopset  type ", coop-capital=" type sum [coopcapital] of newcoopset show ""
      ]
    ]
  ]

end





;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; update-loyalty
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

to update-loyalty
  ; type "E. increase-loyalty: capital " type capital type " loan " show loan
  if  coopid > 0 [
    set timewithcoop timewithcoop + 1

    if secondarybuyer = 0 [ ; did not cheat
      set loyalty loyalty + cooployaltygrowthrate
    ]

    if loyalty < 0 [ ; leave coop/kicked out
                     ; type "update-loyalty: loyalty " type loyalty type " < 0" show " (exit fishery coop-member)"
      set num-coop-fishers-exit-loyalty num-coop-fishers-exit-loyalty + 1
      set num-coop-cheaters num-coop-cheaters + 1
      let my-coop-id coopid
      let my-coopfriends other fishers with [ coopid = my-coop-id ]
      ;      set cheating-set other cheating-set

      if count my-coopfriends > 0 [
        let coopcapital_to_distribute coopcapital / ( count my-coopfriends )
        ask my-coopfriends [
          set coopcapital coopcapital + coopcapital_to_distribute
        ]
      ]
      fisher-turn-inactive SELF
      ask my-links [die]
    ]
  ]
  if coopid = 0 AND primarybuyer != 0 [ ; no entry/exit between fisher and buyer
    set timewithbuyer timewithbuyer + 1

    if secondarybuyer = 0 [
      set loyalty loyalty + 1
    ]
  ]

  ; cap loyalty

  if loyalty > maxcoopmemberloyalty [
    set loyalty 365
  ]


end




;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; dissolve-coop
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

to coop-dissolve [discount-one]
 set timewithcoop-list [] ; for plotting how long a coop persists

  foreach list-taken-coop-ids [ [?1] ->

    let my-coopset fishers with [ coopid = ?1 ]
    ifelse any? my-coopset [
      let my-coopset-size count my-coopset - discount-one
      set timewithcoop-list lput [timewithcoop] of one-of my-coopset timewithcoop-list
      let sumcoopcapital sum  [ coopcapital ] of my-coopset

      ; distribute coopcapital as a pot
      ask my-coopset [
        set coopcapital sumcoopcapital / my-coopset-size
      ]
      let cooployalty sum  [ loyalty ] of my-coopset

      let dissolve 0
      let coop_tsalive [timewithcoop] of one-of my-coopset

      if cooployalty < 0 [
        if print-std-out = true [
          type "coop-dissolve: loyalty="  type cooployalty type "(< 0)"
        ]
        set num-coop-fishers-exit-loyalty num-coop-fishers-exit-loyalty + my-coopset-size
        set num-coops-dissolve-loyalty num-coops-dissolve-loyalty + 1
        save-data-lifespan-exitreason coop_tsalive 2  5 ;timesteps-alive organization_type exit_reason
        set dissolve 1
      ]

      if sumcoopcapital < coopmincapitalconst AND dissolve != 1 [
        if print-std-out = true [
          type "coop-dissolve: capital="  type sumcoopcapital type " (< coopmincapitalconst " type coopmincapitalconst type ")"
        ]
        set num-coop-fishers-exit-capital num-coop-fishers-exit-capital + my-coopset-size
        set num-coops-dissolve-capital num-coops-dissolve-capital + 1
        save-data-lifespan-exitreason coop_tsalive 2 4 ;timesteps-alive organization_type exit_reason
        set dissolve 1
      ]
      if my-coopset-size < mincoopsize AND dissolve != 1  [
        if print-std-out = true [
          type "coop-dissolve: size="  type my-coopset-size type "(< mincoopsize " type mincoopsize type ")"
        ]
        set num-coop-fishers-exit-size num-coop-fishers-exit-size + my-coopset-size
        set num-coops-dissolve-size num-coops-dissolve-size + 1
        save-data-lifespan-exitreason coop_tsalive 2 5 ;timesteps-alive organization_type exit_reason, size is caused by the other two fishers exiting due to low loyalty hence save as 5 =loyalty
        set dissolve 1
      ]
      if dissolve = 1 [
        if print-std-out = true [
          type "(capital= " type sumcoopcapital type ", size=" type my-coopset-size type ", loyalty=" type cooployalty show " )"
        ]
        set list-taken-coop-ids remove ?1 list-taken-coop-ids ; remove coopid fromlist of coopsids in use
        set list-free-coop-ids fput ?1 list-free-coop-ids ; add coopid to free coopids
        ask my-coopset [
          fisher-turn-inactive SELF
          ask my-links [die]
        ]
      ]
    ]
    [
      set list-taken-coop-ids remove ?1 list-taken-coop-ids ; remove coopid fromlist of coopsids in use
      set list-free-coop-ids fput ?1 list-free-coop-ids ; add coopid to free coopids] ; no one in coop
    ]
  ]
end


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; layout networks and color boats and links
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
to layout

  let my-coopsset fishers with [ coopid > 0 ]
  let my-pcset    fishers with [ coopid = 0 ]
  set coopbudgets []
  set coopindbudgets []
  foreach list-taken-coop-ids [ [?1] ->
    let my-clan-coopset fishers with [ coopid = ?1 ]

    ; budget count for data
    let sumcoopcapital    sum  [ coopcapital ] of my-clan-coopset
    let sumcoopindbudgetcapital sum  [ capital ] of my-clan-coopset
    set coopbudgets lput sumcoopcapital coopbudgets
    set coopindbudgets lput sumcoopindbudgetcapital coopindbudgets

    ask my-clan-coopset [
      set size 2
      ; done in coop-forms create-friendships-with other my-clan-coopset   ;; create bonds between all the agents in the coops
      ;; set color white ;i * 30 + 7                       ;; color them with clan color
      ;; set color don't work in homemade shapes so choose shape with correct color instead
      if clanid = 1 [ set shape "diversboat1blue"]
      if clanid = 2 [ set shape "diversboat1purple"]
      if clanid = 3 [ set shape "diversboat1yellow"]
      if clanid >= 4 [ set shape "diversboat1red"]
    ]
  ]

  ; LAYOUT IS VERY TIMECUMSUMING SO COMMENT OUT FOR DOIGN LONGER RUNS
  if ticks > 0   [ ;AND (100 mod ticks) = true
    repeat 1 [
      layout-spring (my-coopsset with [any? friendship-neighbors ]) friendships 0.18 2 1.2 ;0.4 6 1 (world-width / (sqrt number-of-nodes))
      layout-spring (my-pcset    with [any? partnership-neighbors]) partnerships 0.18 0.5 1.2 ;0.4 6(0.1) 1
    ]
  ]

  ask businesses [
    set color brown
  ]
end


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; fisher-select-buyer
;; only selecting not switching , only switch when cheat
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
to fisher-select-buyer

  if coopid = 0 [

    if primarybuyer = 0 [

      if any? buyers [
        ask buyers [type " fleet " type fleetcatch type " fished " type sum [fishedcatch] of link-neighbors with [breed = fishers] ]
        let buyersneedfishers-set1 buyers with [ buyerdemand - sum [fishedcatch] of link-neighbors with [breed = fishers] > 0 ]
        ;; exclude buyers that have 5 fishers
        type "buyers set 1 "show buyersneedfishers-set1
        let buyersneedfishers-set buyersneedfishers-set1 with [ count link-neighbors with [breed = fishers] < 5 ]
        type "buyers set 2 " show buyersneedfishers-set
        if any? buyersneedfishers-set [
          fisher-select-buyer-from-given-set(buyersneedfishers-set)
        ]
      ]
    ]
  ]
end


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; fisher-select-buyer-from-given-set
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
to fisher-select-buyer-from-given-set [thebuyerset]
  let bestPriceBuyer max-one-of thebuyerset [ price ] ;
  let highestSocialSkillsBuyer  max-one-of thebuyerset [ socialskills ] ;
  ifelse  bestPriceBuyer != nobody AND highestSocialSkillsBuyer != nobody [
    ifelse random-float 1 >= 0.5 [ ;; 50/50 select buyer with highest social skils vs highest price
      set primarybuyer bestPriceBuyer
    ]
    [ set primarybuyer highestSocialSkillsBuyer

    ]
    set-layout-active-fisher SELF
    fisher-switch-buyer
  ]
  [type ticks type " error fisher-select-buyer "  type " the buyer set  " type thebuyerset type " bestPriceBuyer " type bestPriceBuyer type " highestSocialSkillsBuyer  " type highestSocialSkillsBuyer show " "]
end

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; coop-select-fisher
;; this is how many members go fishing, vs staying in if the demand is low
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
to coop-select-fishers
   foreach list-taken-coop-ids [ [?1] ->
    let my-coopset fishers with [ coopid = ?1 ]

    if any? my-coopset [
       let cooptotmarketshare ( [coopfishermarketdemand] of one-of my-coopset ) * groupsizeEQ ; share sohuldn't change even though they loose members
      if ( cooptotmarketshare - sum [fishedcatch] of my-coopset) > 0 [

        let dontstayinfisher one-of my-coopset with [stayin = 1]
        if dontstayinfisher != nobody [
          ask dontstayinfisher [set stayin 0] ; ie go fish
        ]
      ]
    ]
  ]
end



;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; coop-de-select-fishers
;; coops only send out as many fishers as needed to fill the market share they have
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

to coop-de-select-fishers

  foreach list-taken-coop-ids [ [?1] ->
    let my-coopset fishers with [ coopid = ?1 ]

    if any? my-coopset [
      let cooptotmarketshare ( [coopfishermarketdemand] of one-of my-coopset ) * groupsizeEQ ; share sohuldn't change even though they loose members
      if ( cooptotmarketshare - sum [fishedcatch] of my-coopset) < 0 [
        let fishertostayin one-of my-coopset with [stayin = 0]
        ask fishertostayin [set stayin 1]
      ]
    ]
  ]
end
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; buyer-select-fisher
;; market demand infinite, BUT, buyer has a certain capacity. determined by gear. every fisher gets a random marketshare of 5-50 boats per buyer.
;; no limit on marketshare!!!
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
to buyer-select-fisher [set-of-fishers]

  let setoffreefishers []

  ifelse set-of-fishers != nobody [
     set setoffreefishers set-of-fishers
    ]
  ;; else
  [
    set setoffreefishers fishers with [coopid = 0 AND primarybuyer = 0]
  ]
  let currentsupply 0
  ;set vision to less than the whole commmunity
  set setoffreefishers n-of min_ count setoffreefishers round (initialactors / 4) setoffreefishers;
  let newfisher nobody
  if any? setoffreefishers  [ ;; any fishers to ask
    ifelse timestepsalive = 0 [ ;; if buyer just enter he gets 5 random fishers
      set newFisher one-of setoffreefishers
    ]
    [
      if buyerdemand > 0 [ ; need fishers but might have them (buyers market share * market demand)
        let current-number-of-fishers 0

        if any? my-partnerships  [
          set currentsupply sum [fishedcatch] of link-neighbors with [breed = fishers]
          set current-number-of-fishers count link-neighbors with [breed = fishers]
        ]
        if  current-number-of-fishers < maxgroupsizebuyers [
          let inCap fleetcatch * marketprice
          let outCap (fleetcatch * price ) + dailyconsumptionbuyer
          if  outCap - inCap > 0 AND (buyerdemand - currentsupply) < 0
          [
            ;type ticks show "money kicked in +++++++++ but not supply"
          ]
          if (buyerdemand - currentsupply) > 0 [ ; need more fishers
            ; type ticks show "money kicked in ++++------------++++ but not supply"
            if any? setoffreefishers [
              set newFisher max-one-of setoffreefishers [reputation]
            ]
          ]
        ]
      ]
    ]
  ]

  if newFisher != nobody [
    ask self [ create-partnership-with newFisher]
    ask newFisher [ set primarybuyer myself]
    ask newFisher [ set loyalty 0]
    ask newFisher [ set loan 0]
    ask newFisher [ set timewithbuyer 0]
    ask newFisher [ set fishedcatch 0]
    set-layout-active-fisher newFisher
  ]

end

to set-layout-active-fisher [the-fisher]
  if [coopid] of the-fisher = 0 [
    ask the-fisher [ set size 2  set color red  set shape "diversboat1white"  ]
  ]
end

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; buyer-de-select-fishers
;; NOTE! a buyer can stop working with max one fisher per time step
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
to buyer-de-select-fishers
  let num_to_kick_out 0
  let myfishers link-neighbors with [breed = fishers]
  if ( buyerdemand - sum [fishedcatch] of myfishers  ) < 0 [
    set num_to_kick_out 1
  ]

  if num_to_kick_out != 0 [
    if any? myfishers [
      let fishertokickout min-one-of myfishers [ loyalty ]

      ask partnership-with fishertokickout [die]
      fisher-turn-inactive fishertokickout
    ]
  ]

end




;;  ---------------------- FUNCTIONS FISHERS  ----------------------

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; fisher-turn-inactive [the_fisher]
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

to fisher-turn-inactive [the_fisher]

  if the_fisher != 0 AND the_fisher != NOBODY [
    ifelse [ coopid ] of the_fisher > 0 [
      ask the_fisher [ set color orange set shape "boat" set size 1 ]
    ]
    [
      ask the_fisher [ set color blue set shape "boat" set size 1 ]
    ]
    ask the_fisher [ set primarybuyer 0 ]
    ask the_fisher [ set secondarybuyer 0 ]
    ask the_fisher [ set loan 0 ]
    ask the_fisher [ set loyalty 0 ]
    ask the_fisher [ set timewithbuyer 0 ]
    ask the_fisher [ set timewithcoop 0 ]
    ask the_fisher [ set coopid 0]
    ask the_fisher [ set primarywholesaler 0 ]
    ask the_fisher [ set price 0 ]
    ask the_fisher [ set coopcapital 0 ]
    ask the_fisher [ set credits 0 ]
    ask the_fisher [ set coopmanagerialskills 0 ]
    ask the_fisher [ set capital initialcapital]
    ask the_fisher [ set stayin 0]
  ]
end

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; get-loan
;; fishers always get basic loan but not the additional loan
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

to fishers-get-loan
  if coopid  = 0 [
    set timewithbuyer-list lput timewithbuyer timewithbuyer-list

    let additionalloan 0
    if capital < 0 [
      set additionalloan capital * (-1) ; make positive
                                        ; type "additionalloan " show additionalloan
      ;type " additionalloan " show additionalloan
      if [capital] of primarybuyer < additionalloan [
        set additionalloan 0
        ;   show additionalloan
      ]
    ]
    let daily_loan dailycostoffishing
    set capital capital + daily_loan + additionalloan ;; increase capital of fisher with loan
    set loan    loan    + daily_loan + additionalloan ;; keep track of fishers debt

    ;if ticks > 898 [


    ask primarybuyer [set capital ( capital - daily_loan - additionalloan) ] ;; decrease capital
    ask primarybuyer [set credits ( credits + daily_loan + additionalloan) ] ;; increase credits
  ]
  if coopid > 0 [

    let additionalloan 0
    if capital < 0 [
      set additionalloan capital * (-1) ; make positive
      if coopcapital < additionalloan [
        set additionalloan 0
      ]
    ]
    let daily_loan dailycostoffishing
    set capital capital + daily_loan + additionalloan ;; increase capital of fisher with loan
    set loan loan + daily_loan + additionalloan       ;; keep track of fishers debt
    set coopcapital ( coopcapital - daily_loan - additionalloan) ;; decrease capital
    set credits ( credits + daily_loan + additionalloan) ;; increase credits
  ]
end


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; go-fish (sets current effort (fishingskills * individualeffort) and calculates catch for fisherman)
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
to fishers-go-fish
  if (coopid = 0 AND primarybuyer != 0) OR (coopid > 0 AND primarywholesaler != 0);; if active PC fisher or active in a coop
  [
    set capital capital - dailycostoffishing
    let effort 2 * fishingskills * individualeffort * catchability   ;;  "2 * fishingskills" since fishingskills normally distributed around 0.5
    set totaleffort totaleffort + effort
    set fishedcatch stock * effort
  ]

end





;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; set-new-buyer
;; help function
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

to fisher-switch-buyer
  ask my-partnerships [ die ]
  ask self [ create-partnership-with primarybuyer ]
  set loan 0
  set loyalty 0
  set timewithbuyer 0
  set secondarybuyer 0
end

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; to fishers-sell-catch-and-cheating
;; first, fishers that cheat sell their catch
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
to fishers-sell-catch-and-cheating
  ;; PC
  ifelse coopid = 0  [

    if secondarybuyer != 0 AND secondarybuyer != nobody [ ; having a secondary buyer means cheating
      set revenue fishedcatch * [price] of secondarybuyer
      if is-buyer? secondarybuyer [
        ask secondarybuyer [ set capital capital -  [revenue] of myself ]
        ask secondarybuyer [ set fleetcatch  fleetcatch + [fishedcatch] of myself]
      ]
      let decrease_netincome 0
      let net_income revenue - dailyconsumptionfisher - loan
      if net_income > 0 [
        set decrease_netincome  net_income * decrease_netincome_constant
      ]
      set capital capital + revenue - dailyconsumptionfisher - decrease_netincome ;; update fishers net capital
    ]

  ]
  [ ;; --- fisher in coop ----
    if secondarybuyer != 0 AND secondarybuyer != nobody [
      set revenue fishedcatch * [ price ] of secondarybuyer                      ;; fishers income ;; buyer must pay this amount to fisher


      if is-buyer?  secondarybuyer [
        ask secondarybuyer [ set capital capital - [ revenue ] of myself ]
        ask secondarybuyer [ set fleetcatch  fleetcatch + [fishedcatch] of myself]
      ]
      let decrease_netincome 0
      let net_income revenue - dailyconsumptionfisher - loan - coopfee
      if net_income > 0 [
        set decrease_netincome  net_income * decrease_netincome_constant
      ]
      set capital capital + revenue  - dailyconsumptionfisher - decrease_netincome    ;; update fishers net capital
    ]
  ]
end



;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; to fishers-sell-catch - non-cheating fishers sell catch
;; Fisher sells its catch to its buyer or coop
;; here some fisehrs have extra catch if they acted as someones secondarybuyer
;; calculate and set revenue and new capital for fisherman
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
to fishers-sell-catch
  ;; PC
  ifelse coopid = 0  [

    if secondarybuyer = 0 OR secondarybuyer = nobody [ ; check that not a cheater
      set revenue fishedcatch * [price] of primarybuyer
      ask primarybuyer [ set capital    capital    - [revenue]     of myself ]
      ask primarybuyer [ set fleetcatch fleetcatch + [fishedcatch] of myself ]

      let decrease_netincome 0
      let net_income revenue - dailyconsumptionfisher - loan
      if net_income > 0 [
        set decrease_netincome  net_income * decrease_netincome_constant
      ]
      set capital capital + revenue - dailyconsumptionfisher - decrease_netincome             ;; update fishers net capital
    ]
  ]
   ;; coop fishers
  [ if secondarybuyer = 0 OR secondarybuyer = nobody [ ;; check that not a cheater
      ifelse primarywholesaler != 0 [
        set revenue fishedcatch * [ price ] of primarywholesaler * coopmanagerialskills ;
                                                                                        ; type " revenue of coop fisher" type revenue type " price " type   [ price ] of primarywholesaler type " fishedcatch " type fishedcatch  type " coopmanagerialsk " show coopmanagerialsk
        ask primarywholesaler [ set capital capital - [ revenue ] of myself ]       ;; remove capital from buyer
      ]
      [
        type "ERROR (should not happen) fishers-sell-catch: wholesaler missing for the fisher in coop." type "my coopid " type coopid type " me " type self type " my primarywholesaler " type primarywholesaler
      ] ;no wholesaler, not an active coop fisher (should not happen)
      let decrease_netincome 0
      let net_income revenue - dailyconsumptionfisher - loan - coopfee
      if net_income > 0 [
        set decrease_netincome  net_income * decrease_netincome_constant
      ]
      set capital capital + revenue - dailyconsumptionfisher - decrease_netincome    ;; update fishers net capital
    ]
  ]

end

to coop-and-PC-conflict

  if socialdisturbancetype = "stochastic" [

    foreach list-taken-coop-ids [ [?1] ->
      let my-coopset fishers with [ coopid = ?1 ]
      let random-crisis 0
      if conflict-type = "monthly" [
        set random-crisis 20 + random 21;; on average once a month every 30th day
      ]
      if conflict-type = "corruption" [
        set random-crisis 365  ;; yearly
      ]
      if  (ticks - 30) mod random-crisis = 0 [ ;;ticks - 30 gives the yearly subsidie one month after each year, and thus one month after a sub was given
        ask my-coopset [
          if timestepsalive > 365 [
            set loyalty loyalty * ( 1 - loy-reduction-level ); reduce loyalty by x% every time there is a crisis
          ]
        ]
      ]
    ]
    ask fishers with [coopid = 0 AND primarybuyer != nobody AND primarybuyer != 0]
      [
        let random-crisis 0
        if conflict-type = "monthly" [
          set random-crisis 20 + random 21;; on average once a month every 30th day
        ]
        if conflict-type = "corruption" [
          set random-crisis 365;; yearly
        ]

        if ticks > (365 * 2) AND (ticks - 30) mod random-crisis = 0 [  ; starts at the same time as for the first 5 coops (PCs have been around one year longer than coops)
          set loyalty loyalty * ( 1 - loy-reduction-level )
        ]
    ]
    ]
end


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; fisher-cheat
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
to fisher-cheat
  let newbuyer 0
  if secondarybuyer = nobody
  [type "no error here? can be nobody ... ERROR fisher-cheat secondarybuyer = nobody " type self type " secondarybuyer=" type secondarybuyer type " primarybuyer=" show primarybuyer  ]
  ;; PC FISHERS CHEATING
  if coopid = 0 AND primarybuyer != 0 [ ; is an active fisher
        let random-num random-float 1

        if reliability < random-num [
          let cheat_chance 0

          if loyalty < 365 AND cheatingtype = "relloy"[
            set cheat_chance  (365 - loyalty) / 365
          ]

          let cheat-loyalty 0.05 + cheat_chance ;+ exp ( -( loyalty / ( 365 * 2 ))) ;0.05 + exp ( - ( loyalty / 100 ) )
          set random-num random-float 1

          if cheat-loyalty > random-num [

            let set-of-buyers []
            if any? buyers
              [ set set-of-buyers n-of count buyers buyers ]
            let tmp_num-coops (length list-taken-coop-ids)
            let set-of-coop-fishers []
            if tmp_num-coops > 0 [

              set set-of-coop-fishers fishers with [coopid > 0 AND primarywholesaler != 0 AND secondarybuyer = 0 AND stayin = 0]

              if count set-of-coop-fishers > tmp_num-coops [
                set set-of-coop-fishers n-of tmp_num-coops set-of-coop-fishers ]
            ]

            let cheating-set (turtle-set set-of-coop-fishers set-of-buyers)             ; join sets of buyers and fishers
            ;type "before removing prim buyer " show cheating-set

        ask [primarybuyer] of self [ ; remove the buyer from the set
          set cheating-set other cheating-set ]
            set newbuyer one-of cheating-set
            ; ---------end find set of actors to cheat with
            if newbuyer != 0 AND newbuyer != nobody [
              let theloan loan
              ; set economy for the looser buyer
              ask primarybuyer [ set credits max_ ( credits - theloan ) 0 ] ;; will never get back these credits
              ask primarybuyer [ set creditslost creditslost + theloan ]
              set secondarybuyer newbuyer
              set loyalty loyalty - 1

            ]
          ]
        ]
  ]
  ; COOPS CHEATING
  if coopid > 0 [

      let random-num random-float 1

      if reliability < random-num [ ;cheating = "on" OR (cheating = "on loy" AND the-random < chancecheat) [
        let cheat_chance 0

        if loyalty < 365 AND cheatingtype = "relloy" [
          set cheat_chance  (365 - loyalty) / 365
        ]
        let cheat-loyalty 0.05 + cheat_chance
        set random-num random-float 1

        if cheat-loyalty > random-num [
            let set-of-buyers []
            if any? buyers
              [ set set-of-buyers n-of count buyers buyers ]

            let tmp_num-coops (length list-taken-coop-ids) - 1 ; remove my own coop
            let set-of-coop-fishers []
            if tmp_num-coops > 0 [
             ; type "secondarybuyer " show [secondarybuyer] of fishers with [coopid > 0 AND primarywholesaler != 0]
              let my-coop-id [coopid] of self
              set set-of-coop-fishers fishers with [coopid > 0 AND coopid != my-coop-id AND primarywholesaler != 0 AND secondarybuyer = 0 AND stayin = 0] ; cannot cheat with fisher in own coop
              if count set-of-coop-fishers > tmp_num-coops [
                set set-of-coop-fishers n-of tmp_num-coops set-of-coop-fishers ]
            ]
            let cheating-set (turtle-set set-of-coop-fishers set-of-buyers)             ; join sets of buyers and fishers
            set newbuyer one-of cheating-set

            if newbuyer != 0 AND newbuyer != nobody [
              set secondarybuyer newbuyer
              set loyalty loyalty - 1 ;
            ]
        ]
      ]
  ]
end

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; payback-loan
;; check if payback is needed and possible and do pay back
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
to fishers-payback-loan
 ; type "BEFORE coopid: " type coopid type " loan: " type loan  type " secondarybuyer " type secondarybuyer type " primarybuyer " type primarybuyer type " capital BEFORE: " show capital
  if capital > 0 [
    let pay loan ;  loan is normally only costoffishing
                 ;  only non-cheaters payback loan
    ifelse secondarybuyer = 0 OR secondarybuyer = nobody [
      ; PC
      if coopid  = 0 AND loan > 0 AND capital > 0 AND primarybuyer != 0 [;; payback loan if possible
        if capital < pay [
          set pay capital ; only payback what they can
        ]
        set capital precision (capital - pay) 10 ; fix for last digit error 0.5999999999999999 >= 0.6

        ask primarybuyer [set credits max_ ( credits - pay ) 0 ]  ;; credit is positive
        ask primarybuyer [set capital ( capital + pay ) ]
        set loan loan - pay      ;  loan is reduced with whatever was payed back
      ]
      ;; COOP fishers LOAN
      if coopid > 0 AND capital > 0 [
        set pay pay + coopfee ; coops fishers pay loan and coopfee
        if capital < pay [
          set pay capital ; only pay what you have
        ]
        set capital precision (capital - pay) 10 ; capital is now reduced by loan and coop fee (fix for last digit error 0.5999999999999999 >= 0.6)
        set credits max_ (credits - (pay - coopfee)) 0 ;; credit is positive, remove the credit hthe fisher recovered
        set coopcapital coopcapital + pay  ;; the coopcapital is increased by the loan and coopfee
        set loan loan - (pay - coopfee)    ;; the loan is reduced by the loan part of pay and coopfee that the fisher could pay
        set coopcapital coopcapital - coopfee ;

        if capital > (7 * dailyconsumptionfisher) [
          let excess capital - ( 7 * dailyconsumptionfisher )
          let donate-to-coop-pot excess * 0.0005
          set coopcapital coopcapital + donate-to-coop-pot ; coopcapital is shared among the fishers in the coop
          set capital capital - donate-to-coop-pot
        ]
      ]
    ]
    [
      ; fishers that cheat never pay back the daily loan
      set loan loan - dailycostoffishing ]
  ]
end


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; trade
;; to gather all landings from fishers and calculate
;; new capital for buyer. This is also dependent on managerial skills.
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
to buyers-trade
  ;type "------ primarybuyer before trade "  type  [capital] of self type " fleetcatch "  type fleetcatch
  ifelse fleetcatch > 0 [
    set revenue fleetcatch *  marketprice * managerialskills
    let decrease_netincome 0
    let net_income revenue - dailyconsumptionbuyer - (fleetcatch * price)
    if net_income > 0 [
      set decrease_netincome net_income * decrease_netincome_constant

    ]
    set capital capital + revenue - dailyconsumptionbuyer  - decrease_netincome                   ;; net income per time step
  ]
  [ ;; no fishers working for the buyer
    set capital capital - dailyconsumptionbuyer
    set revenue 0
    set fleetcatch 0
  ]
end

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; select-fisher-turn-buyer
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
to select-fisher-turn-buyer [num-to-turn]
  let freefishersset nobody
  if fisherturnbuyer = "inactive" [
    set freefishersset fishers with [coopid = 0 AND (primarybuyer = 0 OR primarybuyer = nobody) ]
  ]
  if fisherturnbuyer = "inactive+pcf" [
    set freefishersset fishers with [coopid = 0 ]
  ]
  if count freefishersset > 0 [
    ask max-n-of min_ num-to-turn count freefishersset freefishersset [capital][
      ;let the_fisher  max-one-of freefishersset [capital]
      let the_fisher  one-of freefishersset
      fisher-turn-buyer
    ]
  ]
end
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; fisher-turn-buyer
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
to fisher-turn-buyer
  ;; if fisher has debts: payback before switching
  if any? my-partnerships  [    ;; payback loan and maybe have negative capital
    if loan > 0 [
      fishers-payback-loan
    ]
    ask my-partnerships [ die ] ;; break bond with current buyer
  ]
  let fcapital initialcapitalbuyer
  hatch-buyers 1 [set color red set size 2 set shape "fishbuyericon"  set revenue 0 set credits 0 set timestepsalive 0 set capital fcapital setxy random-xcor random-ycor] ; dont own loyalty
  create-business-with one-of wholesalers
  die ;; fisher dies
end

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; buyer-turn-actor
;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
to buyer-turn-actor

  if print-std-out = true [
    type " ticks " type ticks type " buyer-turn-actor: capital=" type capital type " < buyermincapital " show buyermincapital
  ]
  ask link-neighbors with [ breed = fishers ] [ set loan 0 ] ;; fishers loan is reset
  ask link-neighbors with [ breed = fishers ] [ set primarybuyer 0 ]
  ask link-neighbors with [ breed = fishers ] [ set credits 0 ]
  ask link-neighbors with [ breed = fishers ] [ set secondarybuyer 0 ]
  ask link-neighbors with [ breed = fishers ] [ set fishedcatch 0 ]
  ask link-neighbors with [ breed = fishers ] [ set revenue 0 ]
  ask link-neighbors with [ breed = fishers ] [ set timewithbuyer 0 ]
  ask link-neighbors with [ breed = fishers ] [ set capital initialcapital ]
  ask link-neighbors with [ breed = fishers ] [ set shape "diversboat1sad" ]
  set num-buyers-exit-capital num-buyers-exit-capital + 1
  save-data-lifespan-exitreason timestepsalive 1 4 ;timesteps-alive organization_type exit_reason
  let newcapital  initialcapital
  hatch-actors 1 [  set color yellow set size 2 set shape "diversboat1sad" set revenue 0 set credits 0 set timestepsalive 0 set capital newcapital] ; dont own loyalty
  ask my-links [ die ] ;; kill links
  die
end

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;; IMORTANT THESE VALUES MUST BE THE SAME AS THOSE INITIALLY (START VALUES)
;; actor-turn-fisher
;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
to actor-turn-fisher
  ; the fisher inherits everything from the actor, so need to reset some parameters
  hatch-fishers 1 [set stayin 0 set loan 0 set secondarybuyer 0  set primarybuyer 0 set color blue set size 2 set shape "diversboat1" set revenue 0 set credits 0 set timestepsalive 0 set timewithcoop 0 set timewithbuyer 0]

  die
end
@#$#@#$#@
GRAPHICS-WINDOW
147
11
519
384
-1
-1
11.030303030303031
1
10
1
1
1
0
0
0
1
-16
16
-16
16
1
1
1
ticks
30.0

BUTTON
524
10
590
43
setup
setup-interface
NIL
1
T
OBSERVER
NIL
NIL
NIL
NIL
1

BUTTON
635
10
690
43
go
go
T
1
T
OBSERVER
NIL
NIL
NIL
NIL
0

PLOT
713
160
912
312
Stock
time
stock and catch
0.0
10.0
0.0
10.0
true
false
"" ""
PENS
"S" 1.0 2 -16777216 true "" "plot stock"
"MSY" 1.0 0 -7500403 true "" "plot MSYstock"
"pen-2" 1.0 0 -1712915 true "" "plot 0"

TEXTBOX
493
756
678
784
ECOSYSTEM
11
75.0
1

BUTTON
580
10
635
43
Step
go
NIL
1
T
OBSERVER
NIL
NIL
NIL
NIL
0

PLOT
912
10
1111
160
Total No Buyers and Coops
time
No.
0.0
10.0
0.0
17.0
true
false
"" ""
PENS
"buyers" 1.0 2 -10899396 true "" "plot num-buyers"
"coops" 1.0 0 -955883 true "" "plot num-coops"
"pen-2" 1.0 0 -1712915 true "" "plot num-buyers + num-coops"
"pen-3" 1.0 0 -7500403 true "" "plot 10"

PLOT
713
10
913
159
Total No Fishers Fishing
time
No.
0.0
10.0
0.0
100.0
true
false
"" ""
PENS
"default" 1.0 2 -2758414 true "" "plot num-active-fishers"
"MSY" 1.0 0 -7500403 false "" "plot 50"
"pen-2" 1.0 0 -13791810 true "" "plot num-active-pc-fishers"
"pen-3" 1.0 0 -955883 true "" "plot num-active-coop-fishers"
"pen-4" 1.0 0 -612749 true "" "plot count active-coop-fishers with [stayin = 0]"
"pen-5" 1.0 0 -2674135 true "" ";plot count active-coop-fishers with [stayin = 1]"

MONITOR
596
240
667
285
No. Fishers
count fishers
17
1
11

PLOT
1318
10
1520
160
Average Capital of Buyers
NIL
NIL
0.0
10.0
0.0
10.0
true
false
"" ""
PENS
"default" 1.0 2 -15575016 true "" "plot active-buyers-capital"
"pen-1" 1.0 0 -10899396 true "" "if any? buyers [\nlet input [capital] of buyers\nplot-list (input)\n]"
"pen-2" 1.0 0 -7500403 true "" "plot 0"

PLOT
1319
310
1519
460
Av. loans
time
loan
0.0
10.0
0.0
10.0
true
false
"" ""
PENS
"pc-fisher" 1.0 0 -13791810 true "" "if ticks > 0 AND num-active-pc-fishers > 0\n[\nplot sum [loan] of active-pc-fishers / num-active-pc-fishers\n]"
"coop-fisher" 1.0 0 -955883 true "" "if num-active-coop-fishers > 0[\n  plot sum [loan] of active-coop-fishers / num-active-coop-fishers\n]"

PLOT
1524
11
1724
161
Average Credits of Buyer
NIL
NIL
0.0
10.0
0.0
10.0
true
false
"" ""
PENS
"default" 1.0 0 -14333415 true "" "if num-buyers > 0\n[plot buyers-credits]"
"pen-1" 1.0 0 -10899396 true "" "if any? buyers [\nlet input [credits] of buyers\nplot-list (input)\n]"
"zero" 1.0 0 -7500403 true "" "plot 0"

MONITOR
525
194
596
239
No. Buyers
count buyers
17
1
11

MONITOR
596
195
667
240
% buyers of active-fishers
100 * (count buyers /  ( count buyers + num-active-fishers ))
2
1
11

PLOT
1317
161
1517
311
pc-fishers budget
NIL
$
0.0
10.0
0.0
0.07
true
true
"" ""
PENS
"cof" 1.0 0 -11221820 true "" "if ticks > 0 AND  any? active-pc-fishers\n[\nplot sum [dailycostoffishing] of active-pc-fishers / count active-pc-fishers\n\n]"
"daily" 1.0 0 -13791810 true "" "plot dailyconsumptionfisher"
"totex" 1.0 0 -817084 true "" "if ticks > 0 AND any? active-pc-fishers\n[\n\nplot sum [dailycostoffishing] of active-pc-fishers / count active-pc-fishers + dailyconsumptionfisher\n\n]"
"reven" 1.0 0 -8630108 true "" "ifelse ticks > 0 AND any? active-pc-fishers [\n\nplot sum [fishedcatch * [price] of primarybuyer] of active-pc-fishers / count active-pc-fishers\n\n] [plot 0]"
"netin" 1.0 0 -2674135 true "" "if ticks > 0 AND  num-active-pc-fishers > 0\n[\n  plot  (sum [revenue] of active-pc-fishers - sum [dailycostoffishing] of active-pc-fishers ) / num-active-pc-fishers - dailyconsumptionfisher\n]"
"pen-5" 1.0 0 -7500403 false "" "plot 0"

CHOOSER
336
504
477
549
ecosystemdynamicstype
ecosystemdynamicstype
"constant" "seasonal" "uncertain" "uncertain+seasonal"
0

TEXTBOX
177
755
327
773
BUYERS/COOPS
11
55.0
1

TEXTBOX
526
871
728
927
MARKET AND PRICE FLUCTUATIONS
11
122.0
1

MONITOR
525
61
582
106
years
ticks / 365
2
1
11

MONITOR
525
106
639
151
Sum Market Shares
sum [buyermarketshare] of buyers + sum [coopfishersmarketshare] of active-coop-fishers
2
1
11

PLOT
914
160
1114
310
buyers budget
time
costs returns
0.0
10.0
0.0
10.0
true
true
"" ""
PENS
"InRev" 1.0 0 -8630108 true "" "ifelse num-buyers > 0\n[plot sum [revenue] of buyers / num-buyers]\n[plot 0]"
"OutDaily" 1.0 0 -13791810 true "" "plot dailyconsumptionbuyer"
"Net" 1.0 0 -2674135 true "" "ifelse num-buyers > 0\n[plot  (sum [revenue] of buyers ) / num-buyers - dailyconsumptionbuyer]\n[plot 0]"
"zero" 1.0 0 -7500403 true "" "plot 0"
"outF" 1.0 0 -955883 true "" "ifelse num-buyers > 0\n[\nplot   sum ([fleetcatch] of buyers) * sum ([price] of buyers) / num-buyers\n]\n[plot 0]"

MONITOR
596
284
667
329
% InCoop
100 * (num-active-coop-fishers / (num-active-coop-fishers + num-active-pc-fishers))
2
1
11

PLOT
1115
310
1318
464
Av. capital fishers
NIL
NIL
0.0
10.0
0.0
10.0
true
true
"" ""
PENS
"pf" 1.0 2 -13791810 true "" "plot active-pc-fishers-capital"
"cf" 1.0 2 -955883 true "" "plot active-coop-fishers-capital"
"cc" 1.0 0 -6995700 true "" "plot coop-fishers-coop-capital ; times 5 members"
"br" 1.0 0 -13840069 true "" "plot active-buyers-capital"
"PCt" 1.0 2 -6759204 true "" "plot active-pc-fishers-capital + active-buyers-capital"
"COt" 1.0 0 -408670 true "" "plot active-coop-fishers-capital + coop-fishers-coop-capital"

PLOT
714
312
911
459
Av. loyalty COOPmembers
time
loyalty
0.0
10.0
0.0
10.0
true
true
"" ""
PENS
"act fi" 1.0 2 -7500403 true "" "plot active-fishers-loyalty"
"pc" 1.0 2 -13791810 true "" "plot active-pc-fishers-loyalty + 10"
"coop" 1.0 2 -955883 true "" "plot active-coop-fishers-loyalty"

MONITOR
525
151
639
196
active-fishers
num-active-fishers
2
1
11

PLOT
1114
162
1316
310
coop-fishers budget
NIL
$
0.0
10.0
-0.1
0.07
true
true
"" ""
PENS
"rev" 1.0 2 -8630108 true "" "if num-active-coop-fishers > 0 [\n\nplot sum [fishedcatch * [price] of primarywholesaler] of active-coop-fishers / num-active-coop-fishers\n\n]"
"daily" 1.0 0 -13791810 true "" "plot dailyconsumptionfisher"
"netin" 1.0 0 -2674135 true "" "if num-active-coop-fishers > 0 [\n  let totrevenue sum [revenue] of active-coop-fishers\n  let thecof sum [dailycostoffishing] of active-coop-fishers\n  let thecoopfee sum [coopfee] of active-coop-fishers\n\n  plot ((totrevenue - thecof - thecoopfee) / num-active-coop-fishers ) - dailyconsumptionfisher\n]"
"totex" 1.0 0 -817084 true "" "plot dailyconsumptionfisher + coopfee + dailycostoffishing"
"cof" 1.0 0 -11221820 true "" "if num-active-coop-fishers > 0 [\n  plot sum [dailycostoffishing] of active-coop-fishers / num-active-coop-fishers\n]"
"zero" 1.0 0 -7500403 true "" "plot 0"
"rev-dc" 1.0 0 -14835848 true "" "if num-active-coop-fishers > 0 [\n  let totrevenue sum [revenue] of active-coop-fishers\n  plot ((totrevenue) / num-active-coop-fishers ) - dailyconsumptionfisher\n]"
"pen-7" 1.0 0 -6459832 true "" ""

PLOT
912
309
1112
462
Reliability, Rep, Fsk
NIL
NIL
0.0
10.0
0.0
1.0
true
false
"" ""
PENS
"pc" 1.0 0 -13791810 true "" "ifelse num-active-pc-fishers > 0 [\n  plot (sum [reliability] of active-pc-fishers) / num-active-pc-fishers\n]\n[plot 0]"
"coop" 1.0 0 -955883 true "" "ifelse num-active-coop-fishers > 0 [\n  plot (sum [reliability] of active-coop-fishers) / num-active-coop-fishers\n]\n[plot 0]"
"all" 1.0 2 -7500403 true "" ";ifelse num-active-fishers > 0 [\n;  plot sum ([reliability] of active-fishers) / num-active-fishers\n;]\n;[plot 0]"
"pen-3" 1.0 0 -11033397 true "" "ifelse num-active-pc-fishers > 0 [\n  plot (sum [reputation] of active-pc-fishers) / num-active-pc-fishers\n]\n[plot 0]"
"pen-4" 1.0 0 -817084 true "" "ifelse num-active-coop-fishers > 0 [\n  plot (sum [reputation] of active-coop-fishers) / num-active-coop-fishers\n]\n[plot 0]"
"pen-5" 1.0 0 -5516827 true "" "ifelse num-active-pc-fishers > 0 [\n  plot ((sum [fishingskills] of active-pc-fishers) / num-active-pc-fishers) - 0.5\n]\n[plot 0]"
"pen-6" 1.0 0 -408670 true "" "ifelse num-active-coop-fishers > 0 [\n  plot (sum ([fishingskills] of active-coop-fishers) / num-active-coop-fishers) - 0.5\n]\n[plot 0]"

PLOT
715
458
914
608
gini index vs. time
NIL
NIL
0.0
10.0
0.0
1.0
true
true
"" ""
PENS
"default" 1.0 0 -2674135 true "" "plot 0"
"tot" 1.0 0 -7500403 true "" ";if gini-index-reserve != 0 [\n\nif (num-active-fishers > 0) [\n plot (gini-index-reserve-final)\n ]\n; ]"
"pc" 1.0 0 -13791810 true "" "if (num-active-fishers > 0) [\n plot gini-index-reserve-pc-final\n ]"
"coop" 1.0 2 -955883 true "" "if (num-active-fishers > 0) [\n plot gini-index-reserve-coop-final\n]"

TEXTBOX
337
397
445
416
INTERVENTIONS 
12
25.0
1

PLOT
1519
162
1719
312
capital inactive fishers
NIL
NIL
0.0
10.0
0.0
10.0
true
false
"" ""
PENS
"ave" 1.0 2 -16777216 true "" ";let num-inactive-fishers count fishers with [(coopid = 0 AND selectedbuyer = 0 ) OR (coopid > 0 AND selectedwholesaler = 0)]\nif ticks > 0 AND num-inactive-fishers > 0 [\n   plot inactive-fishers-capital\n]"
"0" 1.0 0 -7500403 true "" "plot 0"
"max" 1.0 0 -2674135 true "" ";let num-inactive-fishers count fishers with [(coopid = 0 AND selectedbuyer = 0 ) OR (coopid > 0 AND selectedwholesaler = 0)]\nif ticks > 0 AND num-inactive-fishers > 0 [\nlet a-fisher  max-one-of  inactive-fishers [capital]\n   plot [capital] of a-fisher\n]"

CHOOSER
24
878
167
923
initconfigpccoops
initconfigpccoops
"pc trans" "mixed" "pc" "coops" "mixed evolving" "pc evolving" "coops evolving" "pc fixed" "coops fixed" "mixed fixed"
0

CHOOSER
334
1052
516
1097
initialcapitaltype
initialcapitaltype
"uniform" "variable" "normal" "non uniform" "uniform sensitivity" "uniform sensitivity coops"
5

TEXTBOX
8
10
158
28
INIT
11
55.0
1

PLOT
916
609
1115
759
Lorentz Curve
Pop %
Wealth %
0.0
100.0
0.0
100.0
false
false
"" ""
PENS
"Equal" 100.0 0 -16777216 true ";; draw a straight line from lower left to upper right\nset-current-plot-pen \"equal\"\nplot 0\nplot 100" ""
"Lorenz" 1.0 0 -7500403 false "" "if empty? lorenz-points = false [\nplot-pen-reset\nlet num-active num-active-fishers + count buyers\nif ticks > 100 AND num-active > 0 [\n  set-plot-pen-interval 100 / num-active\n  plot 0\n  foreach lorenz-points plot\n]\n]"

MONITOR
525
284
597
329
% pc
100 * (num-active-pc-fishers / (num-active-coop-fishers + num-active-pc-fishers))
2
1
11

SLIDER
334
891
474
924
amountgonegative
amountgonegative
-10000
0
0.0
10
1
NIL
HORIZONTAL

CHOOSER
177
924
298
969
managerialskillstype
managerialskillstype
"eq" "rand 0.6 1.4" "rand 0.25 0.75" "rand 0.5 1" "rand 1 1.5" "fixed"
0

CHOOSER
10
448
150
493
fishingskillstype
fishingskillstype
"eq" "fixed" "fixedmean" "low" "med" "high"
4

CHOOSER
160
415
265
460
reliabilitytype
reliabilitytype
"eq no cheating" "eq cheating" "fixed" "fixedvar" "fixedcom" "low" "med" "high" "lowD" "medD" "highD"
9

CHOOSER
178
970
296
1015
socialskillstype
socialskillstype
"eq" "rand 0 0.5" "rand 0.25 0.75" "rand 0.5 1" "rand 1 1.5"
0

SLIDER
160
461
293
494
reliabilityvalue
reliabilityvalue
0
1
0.66
0.001
1
NIL
HORIZONTAL

SLIDER
177
891
328
924
managerialskillsvalue
managerialskillsvalue
0
2
1.0
0.1
1
NIL
HORIZONTAL

PLOT
1115
611
1316
761
num fishers per buyer
NIL
NIL
0.0
10.0
0.0
10.0
true
true
"" ""
PENS
"fpb" 1.0 0 -16777216 true "" "if num-active-pc-fishers > 0 [\n  plot  num-active-pc-fishers / num-buyers\n]"
"pcf" 1.0 0 -7500403 true "" "plot num-active-pc-fishers"
"brs" 1.0 0 -2674135 true "" "plot  num-buyers"

PLOT
718
609
914
756
catchability
time
growthrate
0.0
10.0
0.0
0.01
true
false
"" ""
PENS
"default" 1.0 0 -16777216 true "" "plot catchability"
"pen-1" 1.0 0 -7500403 true "" ";let my-list [individualeffort] of active-fishers\n\n;ifelse my-list != 0 [\n;foreach my-list plot\n;]\n;[ plot 0 ]"

SWITCH
5
29
148
62
do-layout
do-layout
0
1
-1000

SWITCH
6
167
147
200
print-std-out
print-std-out
1
1
-1000

PLOT
1518
311
1718
461
cheating
NIL
NIL
0.0
10.0
0.0
1.0
true
false
"" ""
PENS
"co" 1.0 2 -955883 true "" "ifelse num-active-coop-fishers > 0 [\nplot (num-coop-cheaters + 0.2) / num-active-coop-fishers]\n[plot 0]"
"pc" 1.0 2 -13791810 true "" "ifelse num-active-pc-fishers > 0 [\nplot (num-pc-cheaters + 0.2) / num-active-pc-fishers]\n[plot 0]"

PLOT
1111
10
1324
160
Reason for exit
NIL
NIL
0.0
10.0
0.0
10.0
true
true
"" ""
PENS
"pcC" 1.0 0 -14985354 true "" "plot num-pc-fishers-exit-buyer"
"cpL" 1.0 0 -955883 true "" "plot num-coop-fishers-exit-loyalty"
"cpC" 1.0 0 -10146808 true "" "plot num-coop-fishers-exit-capital"
"cpS" 1.0 0 -408670 true "" "plot num-coop-fishers-exit-size"
"BrC" 1.0 0 -13840069 true "" "plot num-buyers-exit-capital"

PLOT
1515
460
1715
610
time with coop 
NIL
NIL
0.0
10.0
0.0
10.0
true
false
"" ""
PENS
"coop" 1.0 2 -955883 true "" "ifelse timewithcoop-list != 0 [\nforeach timewithcoop-list plot\n]\n[ plot 0 ]"

PLOT
1115
460
1315
610
time as buyer
NIL
NIL
0.0
10.0
0.0
10.0
true
false
"" ""
PENS
"default" 1.0 2 -13840069 true "" "ifelse timealivebuyer-list != 0 [\nforeach timealivebuyer-list plot\n]\n[ plot 0 ]"

SLIDER
24
923
167
956
runs
runs
1
100
1.0
1
1
NIL
HORIZONTAL

SWITCH
23
768
166
801
write-on
write-on
0
1
-1000

INPUTBOX
5
62
63
122
steps
10950.0
1
0
Number

CHOOSER
23
801
166
846
runtype
runtype
"sensitivity" "heterogeneity"
0

INPUTBOX
740
829
1072
889
filenameNum
Num_Interface.csv
1
0
String

INPUTBOX
740
887
1072
947
filenameStr
Str_Interface.csv
1
0
String

SLIDER
10
415
150
448
fishingskillsvalue
fishingskillsvalue
0
1
0.5
0.01
1
NIL
HORIZONTAL

CHOOSER
525
964
668
1009
marketpricetype
marketpricetype
"eq" "stock" "rand" "increase"
3

INPUTBOX
740
947
1072
1013
filenameBrs
Brs_Interface.csv
1
0
String

INPUTBOX
740
1012
1073
1073
filenameFshInCP
FshInCP_Interface.csv
1
0
String

INPUTBOX
740
1073
1073
1133
filenameFshwBr
FshwBr_Interface.csv
1
0
String

INPUTBOX
493
768
571
828
growthrateinitial
0.001
1
0
Number

CHOOSER
10
584
148
629
initialloyaltytype
initialloyaltytype
"eq" "low" "med" "high" "fixed" "fixedvar" "365" "0"
4

INPUTBOX
10
492
122
552
initialloyaltyvalue
5.0
1
0
Number

SLIDER
493
827
626
860
catchability-var
catchability-var
0
1
0.9
0.01
1
NIL
HORIZONTAL

PLOT
914
462
1114
609
num cheaters
NIL
NIL
0.0
10.0
0.0
10.0
true
false
"" ""
PENS
"default" 1.0 0 -955883 true "" "plot (num-coop-cheaters + 0.2)"
"pen-1" 1.0 0 -13791810 true "" "plot (num-pc-cheaters + 0.2)"

CHOOSER
334
847
473
892
amountgonegativetype
amountgonegativetype
"eq" "low" "med" "high"
0

SLIDER
336
548
478
581
catchability
catchability
0
2
1.0
0.1
1
NIL
HORIZONTAL

SLIDER
333
1019
515
1052
reduce_daily_consumption
reduce_daily_consumption
0
1
1.0
0.1
1
NIL
HORIZONTAL

SLIDER
333
988
507
1021
decrease_individualeffort
decrease_individualeffort
0
1
1.0
0.1
1
NIL
HORIZONTAL

SLIDER
334
923
474
956
decrease_netincome_constant
decrease_netincome_constant
0
1
0.0
0.1
1
NIL
HORIZONTAL

SLIDER
177
858
313
891
PC_gr_size_multiple
PC_gr_size_multiple
0
10
3.0
1
1
NIL
HORIZONTAL

CHOOSER
5
122
148
167
seedtype
seedtype
"random seed" "seed based on run" "seed 1" "seed 2" "seed 3" "seed 4" "seed 5"
0

CHOOSER
334
769
473
814
cheatingtype
cheatingtype
"relloy" "relnoloy"
0

CHOOSER
177
814
329
859
cooployaltygrowthratetype
cooployaltygrowthratetype
"slow" "half" "high" "aspc"
1

CHOOSER
177
769
315
814
fisherturnbuyer
fisherturnbuyer
"inactive+pcf" "inactive"
1

PLOT
1315
459
1515
609
time with buyer
NIL
NIL
0.0
10.0
0.0
10.0
true
false
"" ""
PENS
"default" 1.0 2 -13791810 true "" "ifelse timewithbuyer-list != 0 [\nforeach timewithbuyer-list plot\n]\n[ plot 0 ]"

SLIDER
334
814
473
847
reliabilityvariance
reliabilityvariance
0
1
0.3
0.05
1
NIL
HORIZONTAL

SLIDER
333
955
468
988
initialcapitalvariance
initialcapitalvariance
0
100
0.0
10
1
NIL
HORIZONTAL

INPUTBOX
740
769
1072
829
filenameLife
Life_Interface.csv
1
0
String

SLIDER
10
552
122
585
initialloyaltySD
initialloyaltySD
0
50
0.0
1
1
NIL
HORIZONTAL

SLIDER
23
845
166
878
coops-per-push
coops-per-push
0
10
5.0
1
1
NIL
HORIZONTAL

MONITOR
525
239
596
284
No. Co-ops
num-coops
17
1
11

CHOOSER
525
919
698
964
marketdemandtype
marketdemandtype
"eq" "lowvar" "medvar" "highvar" "lowlinear" "medlinear" "highlinear" "medvarskewedup" "medvarskeweddown"
0

SLIDER
525
886
685
919
change-market-demand
change-market-demand
0
400
0.0
5
1
NIL
HORIZONTAL

PLOT
1719
163
1895
314
subs_cap_tot
NIL
NIL
0.0
10.0
0.0
10.0
true
false
"" ""
PENS
"default" 1.0 0 -16777216 true "" "plot subs_cap_tot"

PLOT
1733
10
1894
161
subs_loy_tot
NIL
NIL
0.0
10.0
0.0
10.0
true
false
"" ""
PENS
"default" 1.0 0 -16777216 true "" "plot subs_loy_tot"

CHOOSER
27
1093
171
1138
intervention-signal
intervention-signal
"none" "fixed freq" "coop dissolved" "loyalty low" "catch low" "capital low" "cap+loy low" "cap+loy extra low"
1

PLOT
1719
310
1895
460
coop members capital
NIL
NIL
0.0
10.0
0.0
10.0
true
false
"" ""
PENS
"default" 1.0 0 -955883 true "" "let input (list)\nforeach list-taken-coop-ids [ [?1] ->\n    let my-coopset fishers with [ coopid = ?1 ]\n    let sum_cf (sum [capital] of my-coopset) / (count my-coopset)\n    set input lput sum_cf input\n    ]\nplot-list (input)"

PLOT
1717
462
1897
609
coopcapital per coop
NIL
NIL
0.0
10.0
0.0
10.0
true
false
"" ""
PENS
"default" 1.0 2 -12186836 true "" "let input (list)\nforeach list-taken-coop-ids [ [?1] ->\n    let my-coopset fishers with [ coopid = ?1 ]\n    let sum_cf sum [coopcapital] of my-coopset\n    set input lput sum_cf input\n    ]\nplot-list (input)"

SLIDER
28
1060
171
1093
intervention-freq
intervention-freq
0
24
12.0
1
1
NIL
HORIZONTAL

SLIDER
525
1009
665
1042
marketpriceincrate
marketpriceincrate
0
2
1.3
0.1
1
NIL
HORIZONTAL

CHOOSER
527
414
659
459
socialdisturbancetype
socialdisturbancetype
"none" "stochastic"
0

SLIDER
28
1026
190
1059
stop-sub-after-years
stop-sub-after-years
0
30
30.0
1
1
NIL
HORIZONTAL

MONITOR
582
61
639
106
steps
ticks
0
1
11

CHOOSER
336
417
500
462
intervention-matching
intervention-matching
"none" "no sub" "cap" "loy" "cap+loy" "icap" "iloy" "icap+iloy"
4

SWITCH
24
956
167
989
coops_continue_entering
coops_continue_entering
1
1
-1000

PLOT
1712
611
1912
761
subs_cap_tot_part
NIL
NIL
0.0
10.0
0.0
10.0
true
false
"" ""
PENS
"default" 1.0 0 -16777216 true "" "plot subs_cap_tot_part"

TEXTBOX
526
46
676
64
OBSERVABLES
11
125.0
1

TEXTBOX
334
756
484
774
FISHERS
11
84.0
1

TEXTBOX
741
758
891
776
FILE NAMES FOR SAVING
11
43.0
1

TEXTBOX
11
398
264
426
PAPER 1&2 AGENTS PARAMS ANALYZED
11
23.0
1

SLIDER
528
504
679
537
loy-reduction-level
loy-reduction-level
0
1
0.0
0.05
1
NIL
HORIZONTAL

CHOOSER
528
459
659
504
conflict-type
conflict-type
"none" "monthly" "corruption"
0

TEXTBOX
530
398
680
416
CONFLICT
11
125.0
1

TEXTBOX
20
729
925
747
------------------------------------------------------ NOT VARIED IN CORRESPONDING PAPER ---------------------------------------------------
11
0.0
1

TEXTBOX
338
490
488
508
FISHING ENVIRONMENT
11
95.0
1

SLIDER
335
1098
507
1131
initialcapitalvalue
initialcapitalvalue
0
1000
0.0
10
1
NIL
HORIZONTAL

TEXTBOX
27
755
177
773
initial settings
11
95.0
1

TEXTBOX
29
1007
179
1025
Interventions
11
15.0
1

@#$#@#$#@
## WHAT IS IT?
This is a model for exploring under which conditions fishing cooperatives can establish and persist in a small-scale fishing community presently dominated by fishers working under fish buyers (so called patron-client relationships; PCs). 

The goal of this model is to try to identify the mechanism and conditions under which top-down interventions can support transformations towards cooperative governance arrangements in a fishery.  The model has different types of interventions and  contrasts financial subsidies (icap, cap) with social interventions (iloy, loy), where the latter is aimed at increasing loyalty between fishers in a coopertive. The aim is to investigate their effectiveness under different social and ecological conditions (different levels of conflict scenario and in different fishing environments). 

The model is used for examining how external interventions interplay with the internal self-organizing dynamics of the fishery resulting in the establishment or disappearance of cooperatives. The model focuses on the critical moment when the cooperative is introduced and has to successfully establish against the dominant form of self-governance, herein patron-client relationships.

## HOW IT WORKS

The model is set up so that 10 fishbuyer are working with 5 fishers each during one year. Then 5 cooperatives enter, and yet another 5 enter after another year. The model seeks to explore when can these cooperatives persist?

## HOW TO USE IT
Select different types of intervention-matching (i for initial, no suffix means both start-up intervention and repeated interventions are given to co-ops)

set socialdisturbancetype to stochastic, change conflict-type from none, and test different levels of loy-reduction-level (different levels of severity of conflicts; higher values more severe). 

Interface:

- *intervention-matching*; what interventions are given to coops and at what frequency
-- iloy = initial loyalty. Additional loyalty given at coop start-up.
-- loy = loyalty. Loyalty is given at start-up and repeated yearly throughout the simulation.
-- icap = initial capital. Additional capital is given at coop start-up.
-- cap = capital. Capital is given at start-up and repeated yearly throughout the simulation
-- icap+iloy combines start-up interventions.
-- cap+loy combines start-upand repeated interventions.

- *ecosystemdynamicstype*
-- none = baseline model
-- uncertain = unpredictable fishing environment. Catchability of the fish population growth model is varied stochastically.
-- seasonal = the stock biomass in increased or decreased every half year.
-- uncertain + seasonal combines them.

- *socialdisturbancetype*
-- none = baseline model
-- stochastic = conflict happens accordign to *conflict-type*.

- *conflict-type*
-- none = no conflict
-- monthly = monthly conflicts reducing loyalty by *loy-reduction-level*
-- corruption = yearly conflict reducing loyalty by *loy-reduction-level*

Other variables

`fishingskillsvalue` - the mean of fishers fishing skills

`fishingskillstype` - predefined low/mean/high with a certain variance

`reliabilityvariance` - standard deviation of reliability

`reliabilitytype` - predefined mean and variance 

`reliabilityvalue` - fix mean reliability of agents

`initialloyaltytype` - predefined mean and variance 

`initialloyaltyvalue` - fix mean reliability of agents

`initialloyaltySD` - standard deviation of initial loyalty


## THINGS TO NOTICE

How the reasons for coops to go out of business ('reason for exit' plot)

## THINGS TO TRY

Try to get complete coop dominance. Under which conditions is this possible?

## EXTENDING THE MODEL

Many paths are possible. One is to allow coops to ask for subsidies when they need it instead of it given en fixed intervals. This was done using intervention-signal in the current model, but is not fully developed. Make it poosible for coops and or PCs to increase harvesting efforts. Maybe one organization has a different strategy than the other? It would be interesting to look at sustinable resource use, allowing for both overharvesting and for e.g. coops to build some type of rule for creating sustainable resoure use. 

## NOTES FOR PROGRAMMER
- check if a fisher is active: fisher with [selectedbuyer != 0 OR selectedwholesaler != 0] 
- check if a fisher is active and in coop: fisher with [ coopid > 0 AND selectedwholesler != 0] 
- check if a fisher is active and in PC: fisher with [coopid = 0 AND selectedbuyer != 0]
- inactive: also no partnership-links for a PC fisher, no friendship-links for a coop fisher

### CONCISTENCY CHECK

WHAT IS EFFECTED/COMMENTED OUT IN CONCISTENCY CHECK

for fixed number of fishers, buyers or 50/50
- buyer-de-select-fishers
- cheat-buyer
- cheat-fisher
- all parameters are constant, no variability in fishingskills or reliability



## NETLOGO FEATURES

Not that I am aware of.

## RELATED MODELS

The SMILI model:  https://www.openabm.org/model/5513/version/1/view


## CREDITS AND REFERENCES

Developed together with Maja Schlüter and Xavier Basurto, co-authors of the corresponding paper. Tentative title: Transformation Towards Cooperative Governance Arrangements in Small-scale Fisheries—Moving Out of the Patron-client Trap (In submission).
@#$#@#$#@
default
true
0
Polygon -7500403 true true 150 5 40 250 150 205 260 250

airplane
true
0
Polygon -7500403 true true 150 0 135 15 120 60 120 105 15 165 15 195 120 180 135 240 105 270 120 285 150 270 180 285 210 270 165 240 180 180 285 195 285 165 180 105 180 60 165 15

arrow
true
0
Polygon -7500403 true true 150 0 0 150 105 150 105 293 195 293 195 150 300 150

boat
false
0
Polygon -1 true false 63 162 90 207 223 207 290 162
Rectangle -6459832 true false 150 32 157 162
Polygon -13345367 true false 150 34 131 49 145 47 147 48 149 49
Polygon -7500403 true true 158 33 230 157 182 150 169 151 157 156
Polygon -7500403 true true 149 55 88 143 103 139 111 136 117 139 126 145 130 147 139 147 146 146 149 55

boat 2
false
0
Polygon -1 true false 63 162 90 207 223 207 290 162
Rectangle -6459832 true false 150 32 157 162
Polygon -13345367 true false 150 34 131 49 145 47 147 48 149 49
Polygon -7500403 true true 157 54 175 79 174 96 185 102 178 112 194 124 196 131 190 139 192 146 211 151 216 154 157 154
Polygon -7500403 true true 150 74 146 91 139 99 143 114 141 123 137 126 131 129 132 139 142 136 126 142 119 147 148 147

boat 3
false
0
Polygon -1 true false 63 162 90 207 223 207 290 162
Rectangle -6459832 true false 150 32 157 162
Polygon -13345367 true false 150 34 131 49 145 47 147 48 149 49
Polygon -7500403 true true 158 37 172 45 188 59 202 79 217 109 220 130 218 147 204 156 158 156 161 142 170 123 170 102 169 88 165 62
Polygon -7500403 true true 149 66 142 78 139 96 141 111 146 139 148 147 110 147 113 131 118 106 126 71

box
false
0
Polygon -7500403 true true 150 285 285 225 285 75 150 135
Polygon -7500403 true true 150 135 15 75 150 15 285 75
Polygon -7500403 true true 15 75 15 225 150 285 150 135
Line -16777216 false 150 285 150 135
Line -16777216 false 150 135 15 75
Line -16777216 false 150 135 285 75

bug
true
0
Circle -7500403 true true 96 182 108
Circle -7500403 true true 110 127 80
Circle -7500403 true true 110 75 80
Line -7500403 true 150 100 80 30
Line -7500403 true 150 100 220 30

butterfly
true
0
Polygon -7500403 true true 150 165 209 199 225 225 225 255 195 270 165 255 150 240
Polygon -7500403 true true 150 165 89 198 75 225 75 255 105 270 135 255 150 240
Polygon -7500403 true true 139 148 100 105 55 90 25 90 10 105 10 135 25 180 40 195 85 194 139 163
Polygon -7500403 true true 162 150 200 105 245 90 275 90 290 105 290 135 275 180 260 195 215 195 162 165
Polygon -16777216 true false 150 255 135 225 120 150 135 120 150 105 165 120 180 150 165 225
Circle -16777216 true false 135 90 30
Line -16777216 false 150 105 195 60
Line -16777216 false 150 105 105 60

car
false
0
Polygon -7500403 true true 300 180 279 164 261 144 240 135 226 132 213 106 203 84 185 63 159 50 135 50 75 60 0 150 0 165 0 225 300 225 300 180
Circle -16777216 true false 180 180 90
Circle -16777216 true false 30 180 90
Polygon -16777216 true false 162 80 132 78 134 135 209 135 194 105 189 96 180 89
Circle -7500403 true true 47 195 58
Circle -7500403 true true 195 195 58

circle
false
0
Circle -7500403 true true 0 0 300

circle 2
false
0
Circle -7500403 true true 0 0 300
Circle -16777216 true false 30 30 240

cow
false
0
Polygon -7500403 true true 200 193 197 249 179 249 177 196 166 187 140 189 93 191 78 179 72 211 49 209 48 181 37 149 25 120 25 89 45 72 103 84 179 75 198 76 252 64 272 81 293 103 285 121 255 121 242 118 224 167
Polygon -7500403 true true 73 210 86 251 62 249 48 208
Polygon -7500403 true true 25 114 16 195 9 204 23 213 25 200 39 123

cylinder
false
0
Circle -7500403 true true 0 0 300

diversboat1
false
0
Polygon -6459832 true false 0 165 15 180 30 195 45 210 60 210 105 210 180 210 225 210 255 180 300 120 270 135 240 150 180 165 150 165 135 165 105 165 75 165 60 165 0 150
Circle -6459832 true false 45 105 30
Circle -6459832 true false 90 105 30
Circle -6459832 true false 135 105 30
Line -955883 false 60 135 60 165
Line -955883 false 105 135 105 165
Line -955883 false 150 135 150 165

diversboat1blue
false
0
Polygon -11221820 true false 0 165 15 180 30 195 45 210 60 210 105 210 180 210 225 210 255 180 300 120 270 135 240 150 180 165 150 165 135 165 105 165 75 165 60 165 0 150
Circle -6459832 true false 45 105 30
Circle -6459832 true false 90 105 30
Circle -6459832 true false 135 105 30
Line -955883 false 60 135 60 165
Line -955883 false 105 135 105 165
Line -955883 false 150 135 150 165

diversboat1purple
false
0
Polygon -8630108 true false 0 165 15 180 30 195 45 210 60 210 105 210 180 210 225 210 255 180 300 120 270 135 240 150 180 165 150 165 135 165 105 165 75 165 60 165 0 150
Circle -6459832 true false 45 105 30
Circle -6459832 true false 90 105 30
Circle -6459832 true false 135 105 30
Line -955883 false 60 135 60 165
Line -955883 false 105 135 105 165
Line -955883 false 150 135 150 165

diversboat1red
false
0
Polygon -2674135 true false 0 165 15 180 30 195 45 210 60 210 105 210 180 210 225 210 255 180 300 120 270 135 240 150 180 165 150 165 135 165 105 165 75 165 60 165 0 150
Circle -6459832 true false 45 105 30
Circle -6459832 true false 90 105 30
Circle -6459832 true false 135 105 30
Line -955883 false 60 135 60 165
Line -955883 false 105 135 105 165
Line -955883 false 150 135 150 165

diversboat1sad
false
0
Polygon -6459832 true false 0 165 15 180 30 195 45 210 60 210 105 210 180 210 225 210 255 180 300 120 270 135 240 150 180 165 150 165 135 165 105 165 75 165 60 165 0 150
Circle -6459832 true false 45 105 30
Circle -6459832 true false 90 105 30
Circle -6459832 true false 135 105 30
Line -955883 false 60 135 60 165
Line -955883 false 105 135 105 165
Line -955883 false 150 135 150 165
Line -2674135 false 0 300 300 0
Line -2674135 false 0 0 300 300

diversboat1white
false
0
Polygon -1 true false 0 165 15 180 30 195 45 210 60 210 105 210 180 210 225 210 255 180 300 120 270 135 240 150 180 165 150 165 135 165 105 165 75 165 60 165 0 150
Circle -6459832 true false 45 105 30
Circle -6459832 true false 90 105 30
Circle -6459832 true false 135 105 30
Line -955883 false 60 135 60 165
Line -955883 false 105 135 105 165
Line -955883 false 150 135 150 165

diversboat1yellow
false
0
Polygon -1184463 true false 0 165 15 180 30 195 45 210 60 210 105 210 180 210 225 210 255 180 300 120 270 135 240 150 180 165 150 165 135 165 105 165 75 165 60 165 0 150
Circle -6459832 true false 45 105 30
Circle -6459832 true false 90 105 30
Circle -6459832 true false 135 105 30
Line -955883 false 60 135 60 165
Line -955883 false 105 135 105 165
Line -955883 false 150 135 150 165
Circle -6459832 false false 45 105 30

dot
false
0
Circle -7500403 true true 90 90 120

emilietestshape
true
2
Line -955883 true 60 75 210 225
Rectangle -955883 true true 90 90 180 225

face happy
false
0
Circle -7500403 true true 8 8 285
Circle -16777216 true false 60 75 60
Circle -16777216 true false 180 75 60
Polygon -16777216 true false 150 255 90 239 62 213 47 191 67 179 90 203 109 218 150 225 192 218 210 203 227 181 251 194 236 217 212 240

face neutral
false
0
Circle -7500403 true true 8 7 285
Circle -16777216 true false 60 75 60
Circle -16777216 true false 180 75 60
Rectangle -16777216 true false 60 195 240 225

face sad
false
0
Circle -7500403 true true 8 8 285
Circle -16777216 true false 60 75 60
Circle -16777216 true false 180 75 60
Polygon -16777216 true false 150 168 90 184 62 210 47 232 67 244 90 220 109 205 150 198 192 205 210 220 227 242 251 229 236 206 212 183

fish
false
0
Polygon -1 true false 44 131 21 87 15 86 0 120 15 150 0 180 13 214 20 212 45 166
Polygon -1 true false 135 195 119 235 95 218 76 210 46 204 60 165
Polygon -1 true false 75 45 83 77 71 103 86 114 166 78 135 60
Polygon -7500403 true true 30 136 151 77 226 81 280 119 292 146 292 160 287 170 270 195 195 210 151 212 30 166
Circle -16777216 true false 215 106 30

fishbuyericon
false
0
Rectangle -1 true false 120 90 180 90
Polygon -13345367 true false 135 90 150 105 135 180 150 105 165 180 150 105 165 90
Polygon -7500403 true true 120 90 105 90 60 195 90 210 116 154 120 195 90 285 105 300 135 300 150 225 165 300 195 300 210 285 180 195 183 153 225 105 210 90 195 105 180 90 150 165
Circle -7500403 true true 110 5 80
Rectangle -7500403 true true 127 76 172 91
Line -16777216 false 172 90 161 94
Line -16777216 false 128 90 139 94
Line -16777216 false 180 90 150 165
Line -16777216 false 120 90 150 105
Polygon -16777216 true false 195 30 195 60 210 60 210 30
Polygon -7500403 true true 225 105 240 90 210 45 210 75 210 90
Polygon -16777216 false false 195 45 195 30 210 30 210 60 195 60 195 45
Rectangle -7500403 false true 105 90 180 150
Rectangle -7500403 true true 135 60 165 150
Rectangle -7500403 true true 120 90 180 165

flag
false
0
Rectangle -7500403 true true 60 15 75 300
Polygon -7500403 true true 90 150 270 90 90 30
Line -7500403 true 75 135 90 135
Line -7500403 true 75 45 90 45

flower
false
0
Polygon -10899396 true false 135 120 165 165 180 210 180 240 150 300 165 300 195 240 195 195 165 135
Circle -7500403 true true 85 132 38
Circle -7500403 true true 130 147 38
Circle -7500403 true true 192 85 38
Circle -7500403 true true 85 40 38
Circle -7500403 true true 177 40 38
Circle -7500403 true true 177 132 38
Circle -7500403 true true 70 85 38
Circle -7500403 true true 130 25 38
Circle -7500403 true true 96 51 108
Circle -16777216 true false 113 68 74
Polygon -10899396 true false 189 233 219 188 249 173 279 188 234 218
Polygon -10899396 true false 180 255 150 210 105 210 75 240 135 240

house
false
0
Rectangle -7500403 true true 45 120 255 285
Rectangle -16777216 true false 120 210 180 285
Polygon -7500403 true true 15 120 150 15 285 120
Line -16777216 false 30 120 270 120

leaf
false
0
Polygon -7500403 true true 150 210 135 195 120 210 60 210 30 195 60 180 60 165 15 135 30 120 15 105 40 104 45 90 60 90 90 105 105 120 120 120 105 60 120 60 135 30 150 15 165 30 180 60 195 60 180 120 195 120 210 105 240 90 255 90 263 104 285 105 270 120 285 135 240 165 240 180 270 195 240 210 180 210 165 195
Polygon -7500403 true true 135 195 135 240 120 255 105 255 105 285 135 285 165 240 165 195

line
true
0
Line -7500403 true 150 0 150 300

line half
true
0
Line -7500403 true 150 0 150 150

pentagon
false
0
Polygon -7500403 true true 150 15 15 120 60 285 240 285 285 120

person
false
0
Circle -7500403 true true 110 5 80
Polygon -7500403 true true 105 90 120 195 90 285 105 300 135 300 150 225 165 300 195 300 210 285 180 195 195 90
Rectangle -7500403 true true 127 79 172 94
Polygon -7500403 true true 195 90 240 150 225 180 165 105
Polygon -7500403 true true 105 90 60 150 75 180 135 105

person business
false
0
Rectangle -1 true false 120 90 180 180
Polygon -13345367 true false 135 90 150 105 135 180 150 195 165 180 150 105 165 90
Polygon -7500403 true true 120 90 105 90 60 195 90 210 116 154 120 195 90 285 105 300 135 300 150 225 165 300 195 300 210 285 180 195 183 153 210 210 240 195 195 90 180 90 150 165
Circle -7500403 true true 110 5 80
Rectangle -7500403 true true 127 76 172 91
Line -16777216 false 172 90 161 94
Line -16777216 false 128 90 139 94
Polygon -13345367 true false 195 225 195 300 270 270 270 195
Rectangle -13791810 true false 180 225 195 300
Polygon -14835848 true false 180 226 195 226 270 196 255 196
Polygon -13345367 true false 209 202 209 216 244 202 243 188
Line -16777216 false 180 90 150 165
Line -16777216 false 120 90 150 165

person lumberjack
false
0
Polygon -7500403 true true 105 90 120 195 90 285 105 300 135 300 150 225 165 300 195 300 210 285 180 195 195 90
Polygon -2674135 true false 60 196 90 211 114 155 120 196 180 196 187 158 210 211 240 196 195 91 165 91 150 106 150 135 135 91 105 91
Circle -7500403 true true 110 5 80
Rectangle -7500403 true true 127 79 172 94
Polygon -6459832 true false 174 90 181 90 180 195 165 195
Polygon -13345367 true false 180 195 120 195 90 285 105 300 135 300 150 225 165 300 195 300 210 285
Polygon -6459832 true false 126 90 119 90 120 195 135 195
Rectangle -6459832 true false 45 180 255 195
Polygon -16777216 true false 255 165 255 195 240 225 255 240 285 240 300 225 285 195 285 165
Line -16777216 false 135 165 165 165
Line -16777216 false 135 135 165 135
Line -16777216 false 90 135 120 135
Line -16777216 false 105 120 120 120
Line -16777216 false 180 120 195 120
Line -16777216 false 180 135 210 135
Line -16777216 false 90 150 105 165
Line -16777216 false 225 165 210 180
Line -16777216 false 75 165 90 180
Line -16777216 false 210 150 195 165
Line -16777216 false 180 105 210 180
Line -16777216 false 120 105 90 180
Line -16777216 false 150 135 150 165
Polygon -2674135 true false 100 30 104 44 189 24 185 10 173 10 166 1 138 -1 111 3 109 28

plant
false
0
Rectangle -7500403 true true 135 90 165 300
Polygon -7500403 true true 135 255 90 210 45 195 75 255 135 285
Polygon -7500403 true true 165 255 210 210 255 195 225 255 165 285
Polygon -7500403 true true 135 180 90 135 45 120 75 180 135 210
Polygon -7500403 true true 165 180 165 210 225 180 255 120 210 135
Polygon -7500403 true true 135 105 90 60 45 45 75 105 135 135
Polygon -7500403 true true 165 105 165 135 225 105 255 45 210 60
Polygon -7500403 true true 135 90 120 45 150 15 180 45 165 90

scales1
false
2
Circle -1 true false 103 -2 92
Line -1 false 60 255 90 150
Polygon -1 true false 60 255 75 285 135 300 165 300 225 285 240 255 60 255
Line -1 false 210 150 240 255
Line -1 false 150 120 150 75
Line -2674135 false 150 45 150 15
Line -1 false 90 150 105 135
Line -1 false 150 120 105 135
Line -1 false 210 150 195 135
Line -1 false 195 135 150 120
Polygon -1 false false 60 255 75 285 135 300 165 300 225 285 240 255 60 255
Circle -1184463 false false 120 15 60

scales1sad
false
2
Polygon -7500403 false false 60 255 75 285 135 300 165 300 225 285 240 255 60 255
Circle -7500403 true false 103 -2 92
Line -1 false 60 255 90 150
Polygon -7500403 true false 60 255 75 285 135 300 165 300 225 285 240 255 60 255
Line -1 false 210 150 240 255
Line -1 false 150 120 150 75
Line -2674135 false 150 45 150 15
Line -1 false 90 150 105 135
Line -1 false 150 120 105 135
Line -1 false 210 150 195 135
Line -1 false 195 135 150 120
Circle -1184463 false false 120 15 60
Line -2674135 false 0 300 300 0
Line -2674135 false 0 0 315 315

sheep
false
15
Circle -1 true true 203 65 88
Circle -1 true true 70 65 162
Circle -1 true true 150 105 120
Polygon -7500403 true false 218 120 240 165 255 165 278 120
Circle -7500403 true false 214 72 67
Rectangle -1 true true 164 223 179 298
Polygon -1 true true 45 285 30 285 30 240 15 195 45 210
Circle -1 true true 3 83 150
Rectangle -1 true true 65 221 80 296
Polygon -1 true true 195 285 210 285 210 240 240 210 195 210
Polygon -7500403 true false 276 85 285 105 302 99 294 83
Polygon -7500403 true false 219 85 210 105 193 99 201 83

square
false
0
Rectangle -7500403 true true 30 30 270 270

square 2
false
0
Rectangle -7500403 true true 30 30 270 270
Rectangle -16777216 true false 60 60 240 240

star
false
0
Polygon -7500403 true true 151 1 185 108 298 108 207 175 242 282 151 216 59 282 94 175 3 108 116 108

target
false
0
Circle -7500403 true true 0 0 300
Circle -16777216 true false 30 30 240
Circle -7500403 true true 60 60 180
Circle -16777216 true false 90 90 120
Circle -7500403 true true 120 120 60

tree
false
0
Circle -7500403 true true 118 3 94
Rectangle -6459832 true false 120 195 180 300
Circle -7500403 true true 65 21 108
Circle -7500403 true true 116 41 127
Circle -7500403 true true 45 90 120
Circle -7500403 true true 104 74 152

triangle
false
0
Polygon -7500403 true true 150 30 15 255 285 255

triangle 2
false
0
Polygon -7500403 true true 150 30 15 255 285 255
Polygon -16777216 true false 151 99 225 223 75 224

truck
false
0
Rectangle -7500403 true true 4 45 195 187
Polygon -7500403 true true 296 193 296 150 259 134 244 104 208 104 207 194
Rectangle -1 true false 195 60 195 105
Polygon -16777216 true false 238 112 252 141 219 141 218 112
Circle -16777216 true false 234 174 42
Rectangle -7500403 true true 181 185 214 194
Circle -16777216 true false 144 174 42
Circle -16777216 true false 24 174 42
Circle -7500403 false true 24 174 42
Circle -7500403 false true 144 174 42
Circle -7500403 false true 234 174 42

turtle
true
0
Polygon -10899396 true false 215 204 240 233 246 254 228 266 215 252 193 210
Polygon -10899396 true false 195 90 225 75 245 75 260 89 269 108 261 124 240 105 225 105 210 105
Polygon -10899396 true false 105 90 75 75 55 75 40 89 31 108 39 124 60 105 75 105 90 105
Polygon -10899396 true false 132 85 134 64 107 51 108 17 150 2 192 18 192 52 169 65 172 87
Polygon -10899396 true false 85 204 60 233 54 254 72 266 85 252 107 210
Polygon -7500403 true true 119 75 179 75 209 101 224 135 220 225 175 261 128 261 81 224 74 135 88 99

wheel
false
0
Circle -7500403 true true 3 3 294
Circle -16777216 true false 30 30 240
Line -7500403 true 150 285 150 15
Line -7500403 true 15 150 285 150
Circle -7500403 true true 120 120 60
Line -7500403 true 216 40 79 269
Line -7500403 true 40 84 269 221
Line -7500403 true 40 216 269 79
Line -7500403 true 84 40 221 269

wolf
false
0
Polygon -16777216 true false 253 133 245 131 245 133
Polygon -7500403 true true 2 194 13 197 30 191 38 193 38 205 20 226 20 257 27 265 38 266 40 260 31 253 31 230 60 206 68 198 75 209 66 228 65 243 82 261 84 268 100 267 103 261 77 239 79 231 100 207 98 196 119 201 143 202 160 195 166 210 172 213 173 238 167 251 160 248 154 265 169 264 178 247 186 240 198 260 200 271 217 271 219 262 207 258 195 230 192 198 210 184 227 164 242 144 259 145 284 151 277 141 293 140 299 134 297 127 273 119 270 105
Polygon -7500403 true true -1 195 14 180 36 166 40 153 53 140 82 131 134 133 159 126 188 115 227 108 236 102 238 98 268 86 269 92 281 87 269 103 269 113

x
false
0
Polygon -7500403 true true 270 75 225 30 30 225 75 270
Polygon -7500403 true true 30 75 75 30 270 225 225 270
@#$#@#$#@
NetLogo 6.0.1
@#$#@#$#@
@#$#@#$#@
@#$#@#$#@
<experiments>
  <experiment name="sensMatchingNS30IL5C10s10PNASConstant" repetitions="1" runMetricsEveryStep="false">
    <setup>setup</setup>
    <go>go</go>
    <enumeratedValueSet variable="filenameNum">
      <value value="&quot;sensMatchingNS30IL5C10s10PNASConstantnum.csv&quot;"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="filenameStr">
      <value value="&quot;sensMatchingNS30IL5C10s10PNASConstantstr.csv&quot;"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="filenameLife">
      <value value="&quot;sensMatchingNS30IL5C10s10PNASConstantlife.csv&quot;"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="seedtype">
      <value value="&quot;seed based on run&quot;"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="initconfigpccoops">
      <value value="&quot;pc trans&quot;"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="marketpricetype">
      <value value="&quot;increase&quot;"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="marketpriceincrate">
      <value value="1.3"/>
    </enumeratedValueSet>
    <steppedValueSet variable="runs" first="1" step="1" last="10"/>
    <enumeratedValueSet variable="steps">
      <value value="10950"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="beginfilewriting">
      <value value="1"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="runtype">
      <value value="&quot;sensitivity&quot;"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="write-on">
      <value value="true"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="initialloyaltytype">
      <value value="&quot;fixed&quot;"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="initialloyaltyvalue">
      <value value="5"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="print-std-out">
      <value value="false"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="do-layout">
      <value value="false"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="ecosystemdynamicstype">
      <value value="&quot;constant&quot;"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="socialdisturbancetype">
      <value value="&quot;none&quot;"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="initialcapitaltype">
      <value value="&quot;uniform&quot;"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="growthrate">
      <value value="0.001"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="amountgonegative">
      <value value="0"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="intervalforentering">
      <value value="1"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="fishingskillstype">
      <value value="&quot;med&quot;"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="socialskillstype">
      <value value="&quot;eq&quot;"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="socialdistancetype">
      <value value="&quot;eq&quot;"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="reliabilitytype">
      <value value="&quot;medD&quot;"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="managerialskillstype">
      <value value="&quot;eq&quot;"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="cheatingtype">
      <value value="&quot;relloy&quot;"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="cooployaltygrowthratetype">
      <value value="&quot;half&quot;"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="PC_gr_size_multiple">
      <value value="3"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="initiate-innovation">
      <value value="&quot;per-year&quot;"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="coops-per-push">
      <value value="5"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="intervention-signal">
      <value value="&quot;fixed freq&quot;"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="intervention-freq">
      <value value="12"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="stop-sub-after-years">
      <value value="30"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="intervention-matching">
      <value value="&quot;no sub&quot;"/>
      <value value="&quot;icap+iloy&quot;"/>
      <value value="&quot;cap+loy&quot;"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="coops_continue_entering">
      <value value="false"/>
    </enumeratedValueSet>
  </experiment>
  <experiment name="sensMatchingNS30IL5C10s10PNASUncertain" repetitions="1" runMetricsEveryStep="false">
    <setup>setup</setup>
    <go>go</go>
    <enumeratedValueSet variable="filenameNum">
      <value value="&quot;sensMatchingNS30IL5C10s10PNASUncertainnum.csv&quot;"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="filenameStr">
      <value value="&quot;sensMatchingNS30IL5C10s10PNASUncertainstr.csv&quot;"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="filenameLife">
      <value value="&quot;sensMatchingNS30IL5C10s10PNASUncertainlife.csv&quot;"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="seedtype">
      <value value="&quot;seed based on run&quot;"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="initconfigpccoops">
      <value value="&quot;pc trans&quot;"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="marketpricetype">
      <value value="&quot;increase&quot;"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="marketpriceincrate">
      <value value="1.3"/>
    </enumeratedValueSet>
    <steppedValueSet variable="runs" first="1" step="1" last="10"/>
    <enumeratedValueSet variable="steps">
      <value value="10950"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="beginfilewriting">
      <value value="1"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="runtype">
      <value value="&quot;sensitivity&quot;"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="write-on">
      <value value="true"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="initialloyaltytype">
      <value value="&quot;fixed&quot;"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="initialloyaltyvalue">
      <value value="5"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="print-std-out">
      <value value="false"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="do-layout">
      <value value="false"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="ecosystemdynamicstype">
      <value value="&quot;uncertain&quot;"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="socialdisturbancetype">
      <value value="&quot;none&quot;"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="initialcapitaltype">
      <value value="&quot;uniform&quot;"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="growthrate">
      <value value="0.001"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="amountgonegative">
      <value value="0"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="intervalforentering">
      <value value="1"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="fishingskillstype">
      <value value="&quot;med&quot;"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="socialskillstype">
      <value value="&quot;eq&quot;"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="socialdistancetype">
      <value value="&quot;eq&quot;"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="reliabilitytype">
      <value value="&quot;medD&quot;"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="managerialskillstype">
      <value value="&quot;eq&quot;"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="cheatingtype">
      <value value="&quot;relloy&quot;"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="cooployaltygrowthratetype">
      <value value="&quot;half&quot;"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="PC_gr_size_multiple">
      <value value="3"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="initiate-innovation">
      <value value="&quot;per-year&quot;"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="coops-per-push">
      <value value="5"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="intervention-signal">
      <value value="&quot;fixed freq&quot;"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="intervention-freq">
      <value value="12"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="stop-sub-after-years">
      <value value="30"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="intervention-matching">
      <value value="&quot;no sub&quot;"/>
      <value value="&quot;icap+iloy&quot;"/>
      <value value="&quot;cap+loy&quot;"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="coops_continue_entering">
      <value value="false"/>
    </enumeratedValueSet>
  </experiment>
  <experiment name="sensMatchingNS30IL5C10s10PNASStochasticLoy" repetitions="1" runMetricsEveryStep="false">
    <setup>setup</setup>
    <go>go</go>
    <enumeratedValueSet variable="filenameNum">
      <value value="&quot;sensMatchingNS30IL5C10s10PNASStochasticLoynum.csv&quot;"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="filenameStr">
      <value value="&quot;sensMatchingNS30IL5C10s10PNASStochasticLoystr.csv&quot;"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="filenameLife">
      <value value="&quot;sensMatchingNS30IL5C10s10PNASStochasticLoylife.csv&quot;"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="seedtype">
      <value value="&quot;seed based on run&quot;"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="initconfigpccoops">
      <value value="&quot;pc trans&quot;"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="marketpricetype">
      <value value="&quot;increase&quot;"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="marketpriceincrate">
      <value value="1.3"/>
    </enumeratedValueSet>
    <steppedValueSet variable="runs" first="1" step="1" last="10"/>
    <enumeratedValueSet variable="steps">
      <value value="10950"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="beginfilewriting">
      <value value="1"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="runtype">
      <value value="&quot;sensitivity&quot;"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="write-on">
      <value value="true"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="initialloyaltytype">
      <value value="&quot;fixed&quot;"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="initialloyaltyvalue">
      <value value="5"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="print-std-out">
      <value value="false"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="do-layout">
      <value value="false"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="ecosystemdynamicstype">
      <value value="&quot;constant&quot;"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="socialdisturbancetype">
      <value value="&quot;stochastic&quot;"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="initialcapitaltype">
      <value value="&quot;uniform&quot;"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="growthrate">
      <value value="0.001"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="amountgonegative">
      <value value="0"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="intervalforentering">
      <value value="1"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="fishingskillstype">
      <value value="&quot;med&quot;"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="socialskillstype">
      <value value="&quot;eq&quot;"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="socialdistancetype">
      <value value="&quot;eq&quot;"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="reliabilitytype">
      <value value="&quot;medD&quot;"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="managerialskillstype">
      <value value="&quot;eq&quot;"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="cheatingtype">
      <value value="&quot;relloy&quot;"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="cooployaltygrowthratetype">
      <value value="&quot;half&quot;"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="PC_gr_size_multiple">
      <value value="3"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="initiate-innovation">
      <value value="&quot;per-year&quot;"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="coops-per-push">
      <value value="5"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="intervention-signal">
      <value value="&quot;fixed freq&quot;"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="intervention-freq">
      <value value="12"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="stop-sub-after-years">
      <value value="30"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="intervention-matching">
      <value value="&quot;no sub&quot;"/>
      <value value="&quot;icap+iloy&quot;"/>
      <value value="&quot;cap+loy&quot;"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="coops_continue_entering">
      <value value="false"/>
    </enumeratedValueSet>
  </experiment>
  <experiment name="sensMatchingNS30IL5C10s10PNASUncertainStochasticLoy" repetitions="1" runMetricsEveryStep="false">
    <setup>setup</setup>
    <go>go</go>
    <enumeratedValueSet variable="filenameNum">
      <value value="&quot;sensMatchingNS30IL5C10s10PNASUncertainStochasticLoynum.csv&quot;"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="filenameStr">
      <value value="&quot;sensMatchingNS30IL5C10s10PNASUncertainStochasticLoystr.csv&quot;"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="filenameLife">
      <value value="&quot;sensMatchingNS30IL5C10s10PNASUncertainStochasticLoylife.csv&quot;"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="seedtype">
      <value value="&quot;seed based on run&quot;"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="initconfigpccoops">
      <value value="&quot;pc trans&quot;"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="marketpricetype">
      <value value="&quot;increase&quot;"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="marketpriceincrate">
      <value value="1.3"/>
    </enumeratedValueSet>
    <steppedValueSet variable="runs" first="1" step="1" last="10"/>
    <enumeratedValueSet variable="steps">
      <value value="10950"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="beginfilewriting">
      <value value="1"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="runtype">
      <value value="&quot;sensitivity&quot;"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="write-on">
      <value value="true"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="initialloyaltytype">
      <value value="&quot;fixed&quot;"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="initialloyaltyvalue">
      <value value="5"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="print-std-out">
      <value value="false"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="do-layout">
      <value value="false"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="ecosystemdynamicstype">
      <value value="&quot;uncertain&quot;"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="socialdisturbancetype">
      <value value="&quot;stochastic&quot;"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="initialcapitaltype">
      <value value="&quot;uniform&quot;"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="growthrate">
      <value value="0.001"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="amountgonegative">
      <value value="0"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="intervalforentering">
      <value value="1"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="fishingskillstype">
      <value value="&quot;med&quot;"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="socialskillstype">
      <value value="&quot;eq&quot;"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="socialdistancetype">
      <value value="&quot;eq&quot;"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="reliabilitytype">
      <value value="&quot;medD&quot;"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="managerialskillstype">
      <value value="&quot;eq&quot;"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="cheatingtype">
      <value value="&quot;relloy&quot;"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="cooployaltygrowthratetype">
      <value value="&quot;half&quot;"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="PC_gr_size_multiple">
      <value value="3"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="initiate-innovation">
      <value value="&quot;per-year&quot;"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="coops-per-push">
      <value value="5"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="intervention-signal">
      <value value="&quot;fixed freq&quot;"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="intervention-freq">
      <value value="12"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="stop-sub-after-years">
      <value value="30"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="intervention-matching">
      <value value="&quot;no sub&quot;"/>
      <value value="&quot;icap+iloy&quot;"/>
      <value value="&quot;cap+loy&quot;"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="coops_continue_entering">
      <value value="false"/>
    </enumeratedValueSet>
  </experiment>
  <experiment name="sensMatchingLL30IL5C10s10PNASStochasticLoy" repetitions="1" runMetricsEveryStep="false">
    <setup>setup</setup>
    <go>go</go>
    <enumeratedValueSet variable="filenameNum">
      <value value="&quot;sensMatchingLL30IL5C10s10PNASStochasticLoynum.csv&quot;"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="filenameStr">
      <value value="&quot;sensMatchingLL30IL5C10s10PNASStochasticLoystr.csv&quot;"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="filenameLife">
      <value value="&quot;sensMatchingLL30IL5C10s10PNASStochasticLoylife.csv&quot;"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="seedtype">
      <value value="&quot;seed based on run&quot;"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="initconfigpccoops">
      <value value="&quot;pc trans&quot;"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="marketpricetype">
      <value value="&quot;increase&quot;"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="marketpriceincrate">
      <value value="1.3"/>
    </enumeratedValueSet>
    <steppedValueSet variable="runs" first="1" step="1" last="10"/>
    <enumeratedValueSet variable="steps">
      <value value="10950"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="beginfilewriting">
      <value value="1"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="runtype">
      <value value="&quot;sensitivity&quot;"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="write-on">
      <value value="true"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="initialloyaltytype">
      <value value="&quot;fixed&quot;"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="initialloyaltyvalue">
      <value value="5"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="print-std-out">
      <value value="false"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="do-layout">
      <value value="false"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="ecosystemdynamicstype">
      <value value="&quot;constant&quot;"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="socialdisturbancetype">
      <value value="&quot;stochastic&quot;"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="initialcapitaltype">
      <value value="&quot;uniform&quot;"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="growthrate">
      <value value="0.001"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="amountgonegative">
      <value value="0"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="intervalforentering">
      <value value="1"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="fishingskillstype">
      <value value="&quot;med&quot;"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="socialskillstype">
      <value value="&quot;eq&quot;"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="socialdistancetype">
      <value value="&quot;eq&quot;"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="reliabilitytype">
      <value value="&quot;medD&quot;"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="managerialskillstype">
      <value value="&quot;eq&quot;"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="cheatingtype">
      <value value="&quot;relloy&quot;"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="cooployaltygrowthratetype">
      <value value="&quot;half&quot;"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="PC_gr_size_multiple">
      <value value="3"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="initiate-innovation">
      <value value="&quot;per-year&quot;"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="coops-per-push">
      <value value="5"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="intervention-signal">
      <value value="&quot;fixed freq&quot;"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="intervention-freq">
      <value value="12"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="stop-sub-after-years">
      <value value="30"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="intervention-matching">
      <value value="&quot;cap+loy&quot;"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="coops_continue_entering">
      <value value="false"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="loy-reduction-level">
      <value value="0"/>
      <value value="0.1"/>
      <value value="0.2"/>
      <value value="0.4"/>
      <value value="0.8"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="conflict-type">
      <value value="&quot;monthly&quot;"/>
    </enumeratedValueSet>
  </experiment>
  <experiment name="sensMatchingLLCorrupt30IL5C10s10PNASStochasticLoy" repetitions="1" runMetricsEveryStep="false">
    <setup>setup</setup>
    <go>go</go>
    <enumeratedValueSet variable="filenameNum">
      <value value="&quot;sensMatchingLLCorrupt30IL5C10s10PNASStochasticLoynum.csv&quot;"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="filenameStr">
      <value value="&quot;sensMatchingLLCorrupt30IL5C10s10PNASStochasticLoystr.csv&quot;"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="filenameLife">
      <value value="&quot;sensMatchingLLCorrupt30IL5C10s10PNASStochasticLoylife.csv&quot;"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="seedtype">
      <value value="&quot;seed based on run&quot;"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="initconfigpccoops">
      <value value="&quot;pc trans&quot;"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="marketpricetype">
      <value value="&quot;increase&quot;"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="marketpriceincrate">
      <value value="1.3"/>
    </enumeratedValueSet>
    <steppedValueSet variable="runs" first="1" step="1" last="10"/>
    <enumeratedValueSet variable="steps">
      <value value="10950"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="beginfilewriting">
      <value value="1"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="runtype">
      <value value="&quot;sensitivity&quot;"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="write-on">
      <value value="true"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="initialloyaltytype">
      <value value="&quot;fixed&quot;"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="initialloyaltyvalue">
      <value value="5"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="print-std-out">
      <value value="false"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="do-layout">
      <value value="false"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="ecosystemdynamicstype">
      <value value="&quot;constant&quot;"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="socialdisturbancetype">
      <value value="&quot;stochastic&quot;"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="initialcapitaltype">
      <value value="&quot;uniform&quot;"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="growthrate">
      <value value="0.001"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="amountgonegative">
      <value value="0"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="intervalforentering">
      <value value="1"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="fishingskillstype">
      <value value="&quot;med&quot;"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="socialskillstype">
      <value value="&quot;eq&quot;"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="socialdistancetype">
      <value value="&quot;eq&quot;"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="reliabilitytype">
      <value value="&quot;medD&quot;"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="managerialskillstype">
      <value value="&quot;eq&quot;"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="cheatingtype">
      <value value="&quot;relloy&quot;"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="cooployaltygrowthratetype">
      <value value="&quot;half&quot;"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="PC_gr_size_multiple">
      <value value="3"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="initiate-innovation">
      <value value="&quot;per-year&quot;"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="coops-per-push">
      <value value="5"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="intervention-signal">
      <value value="&quot;fixed freq&quot;"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="intervention-freq">
      <value value="12"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="stop-sub-after-years">
      <value value="30"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="intervention-matching">
      <value value="&quot;cap+loy&quot;"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="coops_continue_entering">
      <value value="false"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="loy-reduction-level">
      <value value="0"/>
      <value value="0.2"/>
      <value value="0.4"/>
      <value value="0.6"/>
      <value value="0.8"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="conflict-type">
      <value value="&quot;corruption&quot;"/>
    </enumeratedValueSet>
  </experiment>
  <experiment name="sensMatchingLL30IL5C10s2000PNASStochasticLoy" repetitions="1" runMetricsEveryStep="false">
    <setup>setup</setup>
    <go>go</go>
    <enumeratedValueSet variable="filenameNum">
      <value value="&quot;sensMatchingLL30IL5C10s2000PNASStochasticLoynum.csv&quot;"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="filenameStr">
      <value value="&quot;sensMatchingLL30IL5C10s2000PNASStochasticLoystr.csv&quot;"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="filenameLife">
      <value value="&quot;sensMatchingLL30IL5C10s2000PNASStochasticLoylife.csv&quot;"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="seedtype">
      <value value="&quot;seed based on run&quot;"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="initconfigpccoops">
      <value value="&quot;pc trans&quot;"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="marketpricetype">
      <value value="&quot;increase&quot;"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="marketpriceincrate">
      <value value="1.3"/>
    </enumeratedValueSet>
    <steppedValueSet variable="runs" first="1" step="1" last="2000"/>
    <enumeratedValueSet variable="steps">
      <value value="10950"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="beginfilewriting">
      <value value="1"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="runtype">
      <value value="&quot;sensitivity&quot;"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="write-on">
      <value value="true"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="initialloyaltytype">
      <value value="&quot;fixed&quot;"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="initialloyaltyvalue">
      <value value="5"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="print-std-out">
      <value value="false"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="do-layout">
      <value value="false"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="ecosystemdynamicstype">
      <value value="&quot;constant&quot;"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="socialdisturbancetype">
      <value value="&quot;stochastic&quot;"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="initialcapitaltype">
      <value value="&quot;uniform&quot;"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="growthrate">
      <value value="0.001"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="amountgonegative">
      <value value="0"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="intervalforentering">
      <value value="1"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="fishingskillstype">
      <value value="&quot;med&quot;"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="socialskillstype">
      <value value="&quot;eq&quot;"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="socialdistancetype">
      <value value="&quot;eq&quot;"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="reliabilitytype">
      <value value="&quot;medD&quot;"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="managerialskillstype">
      <value value="&quot;eq&quot;"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="cheatingtype">
      <value value="&quot;relloy&quot;"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="cooployaltygrowthratetype">
      <value value="&quot;half&quot;"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="PC_gr_size_multiple">
      <value value="3"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="initiate-innovation">
      <value value="&quot;per-year&quot;"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="coops-per-push">
      <value value="5"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="intervention-signal">
      <value value="&quot;fixed freq&quot;"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="intervention-freq">
      <value value="12"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="stop-sub-after-years">
      <value value="30"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="intervention-matching">
      <value value="&quot;cap+loy&quot;"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="coops_continue_entering">
      <value value="false"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="loy-reduction-level">
      <value value="0"/>
      <value value="0.1"/>
      <value value="0.2"/>
      <value value="0.4"/>
      <value value="0.8"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="conflict-type">
      <value value="&quot;monthly&quot;"/>
    </enumeratedValueSet>
  </experiment>
  <experiment name="sensMatchingLLCorrupt30IL5C10s2000PNASStochasticLoy" repetitions="1" runMetricsEveryStep="false">
    <setup>setup</setup>
    <go>go</go>
    <enumeratedValueSet variable="filenameNum">
      <value value="&quot;sensMatchingLLCorrupt30IL5C10s2000PNASStochasticLoynum.csv&quot;"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="filenameStr">
      <value value="&quot;sensMatchingLLCorrupt30IL5C10s2000PNASStochasticLoystr.csv&quot;"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="filenameLife">
      <value value="&quot;sensMatchingLLCorrupt30IL5C10s2000PNASStochasticLoylife.csv&quot;"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="seedtype">
      <value value="&quot;seed based on run&quot;"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="initconfigpccoops">
      <value value="&quot;pc trans&quot;"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="marketpricetype">
      <value value="&quot;increase&quot;"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="marketpriceincrate">
      <value value="1.3"/>
    </enumeratedValueSet>
    <steppedValueSet variable="runs" first="1" step="1" last="2000"/>
    <enumeratedValueSet variable="steps">
      <value value="10950"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="beginfilewriting">
      <value value="1"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="runtype">
      <value value="&quot;sensitivity&quot;"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="write-on">
      <value value="true"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="initialloyaltytype">
      <value value="&quot;fixed&quot;"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="initialloyaltyvalue">
      <value value="5"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="print-std-out">
      <value value="false"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="do-layout">
      <value value="false"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="ecosystemdynamicstype">
      <value value="&quot;constant&quot;"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="socialdisturbancetype">
      <value value="&quot;stochastic&quot;"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="initialcapitaltype">
      <value value="&quot;uniform&quot;"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="growthrate">
      <value value="0.001"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="amountgonegative">
      <value value="0"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="intervalforentering">
      <value value="1"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="fishingskillstype">
      <value value="&quot;med&quot;"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="socialskillstype">
      <value value="&quot;eq&quot;"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="reliabilitytype">
      <value value="&quot;medD&quot;"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="managerialskillstype">
      <value value="&quot;eq&quot;"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="cheatingtype">
      <value value="&quot;relloy&quot;"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="cooployaltygrowthratetype">
      <value value="&quot;half&quot;"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="PC_gr_size_multiple">
      <value value="3"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="coops-per-push">
      <value value="5"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="intervention-signal">
      <value value="&quot;fixed freq&quot;"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="intervention-freq">
      <value value="12"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="stop-sub-after-years">
      <value value="30"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="intervention-matching">
      <value value="&quot;cap+loy&quot;"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="coops_continue_entering">
      <value value="false"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="loy-reduction-level">
      <value value="0"/>
      <value value="0.2"/>
      <value value="0.4"/>
      <value value="0.6"/>
      <value value="0.8"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="conflict-type">
      <value value="&quot;corruption&quot;"/>
    </enumeratedValueSet>
  </experiment>
  <experiment name="sensHistory30IL5C10s500PNASConstant" repetitions="1" runMetricsEveryStep="false">
    <setup>setup</setup>
    <go>go</go>
    <enumeratedValueSet variable="filenameNum">
      <value value="&quot;sensHistory30IL5C10s500PNASConstantnum.csv&quot;"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="filenameStr">
      <value value="&quot;sensHistory30IL5C10s500PNASConstantstr.csv&quot;"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="filenameLife">
      <value value="&quot;sensHistory30IL5C10s500PNASConstantlife.csv&quot;"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="seedtype">
      <value value="&quot;seed based on run&quot;"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="initconfigpccoops">
      <value value="&quot;pc trans&quot;"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="marketpricetype">
      <value value="&quot;increase&quot;"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="marketpriceincrate">
      <value value="1.3"/>
    </enumeratedValueSet>
    <steppedValueSet variable="runs" first="1" step="1" last="500"/>
    <enumeratedValueSet variable="steps">
      <value value="10950"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="beginfilewriting">
      <value value="1"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="runtype">
      <value value="&quot;sensitivity&quot;"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="write-on">
      <value value="true"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="initialloyaltytype">
      <value value="&quot;fixed&quot;"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="initialloyaltyvalue">
      <value value="5"/>
      <value value="20"/>
      <value value="40"/>
      <value value="80"/>
      <value value="160"/>
      <value value="320"/>
      <value value="640"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="print-std-out">
      <value value="false"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="do-layout">
      <value value="false"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="ecosystemdynamicstype">
      <value value="&quot;constant&quot;"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="socialdisturbancetype">
      <value value="&quot;none&quot;"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="initialcapitaltype">
      <value value="&quot;uniform&quot;"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="growthrate">
      <value value="0.001"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="amountgonegative">
      <value value="0"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="intervalforentering">
      <value value="1"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="fishingskillstype">
      <value value="&quot;med&quot;"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="socialskillstype">
      <value value="&quot;eq&quot;"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="reliabilitytype">
      <value value="&quot;medD&quot;"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="managerialskillstype">
      <value value="&quot;eq&quot;"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="cheatingtype">
      <value value="&quot;relloy&quot;"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="cooployaltygrowthratetype">
      <value value="&quot;half&quot;"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="PC_gr_size_multiple">
      <value value="3"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="coops-per-push">
      <value value="5"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="intervention-signal">
      <value value="&quot;fixed freq&quot;"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="intervention-freq">
      <value value="12"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="stop-sub-after-years">
      <value value="30"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="intervention-matching">
      <value value="&quot;none&quot;"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="coops_continue_entering">
      <value value="false"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="loy-reduction-level">
      <value value="0"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="conflict-type">
      <value value="&quot;none&quot;"/>
    </enumeratedValueSet>
  </experiment>
  <experiment name="sensCapital30IL5C10s500PNASConstant" repetitions="1" runMetricsEveryStep="false">
    <setup>setup</setup>
    <go>go</go>
    <enumeratedValueSet variable="filenameNum">
      <value value="&quot;sensCapital30IL5C10s500PNASConstantnum.csv&quot;"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="filenameStr">
      <value value="&quot;sensCapital30IL5C10s500PNASConstantstr.csv&quot;"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="filenameLife">
      <value value="&quot;sensCapital30IL5C10s500PNASConstantlife.csv&quot;"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="seedtype">
      <value value="&quot;seed based on run&quot;"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="initconfigpccoops">
      <value value="&quot;pc trans&quot;"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="marketpricetype">
      <value value="&quot;increase&quot;"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="marketpriceincrate">
      <value value="1.3"/>
    </enumeratedValueSet>
    <steppedValueSet variable="runs" first="1" step="1" last="500"/>
    <enumeratedValueSet variable="steps">
      <value value="10950"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="beginfilewriting">
      <value value="1"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="runtype">
      <value value="&quot;sensitivity&quot;"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="write-on">
      <value value="true"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="initialloyaltytype">
      <value value="&quot;fixed&quot;"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="initialloyaltyvalue">
      <value value="5"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="print-std-out">
      <value value="false"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="do-layout">
      <value value="false"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="ecosystemdynamicstype">
      <value value="&quot;constant&quot;"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="socialdisturbancetype">
      <value value="&quot;none&quot;"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="initialcapitaltype">
      <value value="&quot;uniform sensitivity&quot;"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="growthrate">
      <value value="0.001"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="amountgonegative">
      <value value="0"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="intervalforentering">
      <value value="1"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="fishingskillstype">
      <value value="&quot;med&quot;"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="socialskillstype">
      <value value="&quot;eq&quot;"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="reliabilitytype">
      <value value="&quot;medD&quot;"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="managerialskillstype">
      <value value="&quot;eq&quot;"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="cheatingtype">
      <value value="&quot;relloy&quot;"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="cooployaltygrowthratetype">
      <value value="&quot;half&quot;"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="PC_gr_size_multiple">
      <value value="3"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="coops-per-push">
      <value value="5"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="intervention-signal">
      <value value="&quot;fixed freq&quot;"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="intervention-freq">
      <value value="12"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="stop-sub-after-years">
      <value value="30"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="intervention-matching">
      <value value="&quot;none&quot;"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="coops_continue_entering">
      <value value="false"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="loy-reduction-level">
      <value value="0"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="conflict-type">
      <value value="&quot;none&quot;"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="initialcapitalvalue">
      <value value="0"/>
      <value value="25"/>
      <value value="50"/>
      <value value="100"/>
      <value value="500"/>
      <value value="1000"/>
      <value value="10000"/>
    </enumeratedValueSet>
  </experiment>
  <experiment name="sensCapitalCoops30IL5C10s500PNASConstant" repetitions="1" runMetricsEveryStep="false">
    <setup>setup</setup>
    <go>go</go>
    <enumeratedValueSet variable="filenameNum">
      <value value="&quot;sensCapitalCoops30IL5C10s500PNASConstantnum.csv&quot;"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="filenameStr">
      <value value="&quot;sensCapitalCoops30IL5C10s500PNASConstantstr.csv&quot;"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="filenameLife">
      <value value="&quot;sensCapitalCoops30IL5C10s500PNASConstantlife.csv&quot;"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="seedtype">
      <value value="&quot;seed based on run&quot;"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="initconfigpccoops">
      <value value="&quot;pc trans&quot;"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="marketpricetype">
      <value value="&quot;increase&quot;"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="marketpriceincrate">
      <value value="1.3"/>
    </enumeratedValueSet>
    <steppedValueSet variable="runs" first="1" step="1" last="500"/>
    <enumeratedValueSet variable="steps">
      <value value="10950"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="beginfilewriting">
      <value value="1"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="runtype">
      <value value="&quot;sensitivity&quot;"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="write-on">
      <value value="true"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="initialloyaltytype">
      <value value="&quot;fixed&quot;"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="initialloyaltyvalue">
      <value value="5"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="print-std-out">
      <value value="false"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="do-layout">
      <value value="false"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="ecosystemdynamicstype">
      <value value="&quot;constant&quot;"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="socialdisturbancetype">
      <value value="&quot;none&quot;"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="initialcapitaltype">
      <value value="&quot;uniform sensitivity coops&quot;"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="growthrate">
      <value value="0.001"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="amountgonegative">
      <value value="0"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="intervalforentering">
      <value value="1"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="fishingskillstype">
      <value value="&quot;med&quot;"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="socialskillstype">
      <value value="&quot;eq&quot;"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="reliabilitytype">
      <value value="&quot;medD&quot;"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="managerialskillstype">
      <value value="&quot;eq&quot;"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="cheatingtype">
      <value value="&quot;relloy&quot;"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="cooployaltygrowthratetype">
      <value value="&quot;half&quot;"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="PC_gr_size_multiple">
      <value value="3"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="coops-per-push">
      <value value="5"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="intervention-signal">
      <value value="&quot;fixed freq&quot;"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="intervention-freq">
      <value value="12"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="stop-sub-after-years">
      <value value="30"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="intervention-matching">
      <value value="&quot;none&quot;"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="coops_continue_entering">
      <value value="false"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="loy-reduction-level">
      <value value="0"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="conflict-type">
      <value value="&quot;none&quot;"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="initialcapitalvalue">
      <value value="0"/>
      <value value="25"/>
      <value value="50"/>
      <value value="100"/>
      <value value="500"/>
      <value value="1000"/>
      <value value="10000"/>
    </enumeratedValueSet>
  </experiment>
  <experiment name="sensMatchingIIIL5C10s2000" repetitions="1" runMetricsEveryStep="true">
    <setup>setup</setup>
    <go>go</go>
    <metric>count turtles</metric>
    <enumeratedValueSet variable="filenameNum">
      <value value="&quot;sensMatchingIIIL5C10s2000Constantnum.csv&quot;"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="filenameStr">
      <value value="&quot;sensMatchingIIIL5C10s2000Constantstr.csv&quot;"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="filenameLife">
      <value value="&quot;sensMatchingIIIL5C10s2000Constantlife.csv&quot;"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="seedtype">
      <value value="&quot;seed based on run&quot;"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="initconfigpccoops">
      <value value="&quot;pc trans&quot;"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="marketpricetype">
      <value value="&quot;increase&quot;"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="marketpriceincrate">
      <value value="1.3"/>
    </enumeratedValueSet>
    <steppedValueSet variable="runs" first="1" step="1" last="2000"/>
    <enumeratedValueSet variable="steps">
      <value value="10950"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="beginfilewriting">
      <value value="1"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="runtype">
      <value value="&quot;sensitivity&quot;"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="write-on">
      <value value="true"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="initialloyaltytype">
      <value value="&quot;fixed&quot;"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="initialloyaltyvalue">
      <value value="5"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="print-std-out">
      <value value="false"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="do-layout">
      <value value="false"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="ecosystemdynamicstype">
      <value value="&quot;constant&quot;"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="socialdisturbancetype">
      <value value="&quot;none&quot;"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="initialcapitaltype">
      <value value="&quot;uniform&quot;"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="growthrate">
      <value value="0.001"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="amountgonegative">
      <value value="0"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="intervalforentering">
      <value value="1"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="fishingskillstype">
      <value value="&quot;med&quot;"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="socialskillstype">
      <value value="&quot;eq&quot;"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="reliabilitytype">
      <value value="&quot;medD&quot;"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="managerialskillstype">
      <value value="&quot;eq&quot;"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="cheatingtype">
      <value value="&quot;relloy&quot;"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="cooployaltygrowthratetype">
      <value value="&quot;half&quot;"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="PC_gr_size_multiple">
      <value value="3"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="coops-per-push">
      <value value="5"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="intervention-signal">
      <value value="&quot;none&quot;"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="intervention-freq">
      <value value="12"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="stop-sub-after-years">
      <value value="10"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="intervention-matching">
      <value value="&quot;no sub&quot;"/>
      <value value="&quot;icap&quot;"/>
      <value value="&quot;iloy&quot;"/>
      <value value="&quot;icap+iloy&quot;"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="coops_continue_entering">
      <value value="false"/>
    </enumeratedValueSet>
  </experiment>
</experiments>
@#$#@#$#@
@#$#@#$#@
default
0.0
-0.2 0 0.0 1.0
0.0 1 1.0 0.0
0.2 0 0.0 1.0
link direction
true
0
Line -7500403 true 150 150 90 180
Line -7500403 true 150 150 210 180
@#$#@#$#@
0
@#$#@#$#@
